<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: admin_users.php,v 1.5 2009/02/23 13:13:25 sagarwal Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class admin_users
{
	public $u_action;
	
	private $pbx_admin_ary = array(
		'firstname'				=> '',
		'lastname'				=> '',
		'phone_num'				=> '',
		'web_login'				=> '',
		'web_login_password'	=> '',
		'web_login_password_confirm'	=> '',
	);

	function main($id, $mode)
	{
		global $user, $template, $soap, $common_path, $phpEx;
		$action = request_var('action', '');
		$cont_id = '';
		
		// validation of required field
		if (post_var('validate_data'))
		{
			require($common_path . 'includes/functions_user.' . $phpEx);
			$this->pbx_admin_ary = $this->request_vars($this->pbx_admin_ary);
			$error = validate_data($this->pbx_admin_ary, array(
				'firstname'				=> array(
					array('string', false, 1, 128)),
				'lastname'				=> array(
					array('string', false, 1, 128)),
				'web_login'					=> array(
					array('string', false, 1, 128 )),
				'web_login_password'		=> array(
					array('string', false, 1, 28)),
				'web_login_password_confirm' => array(
					array('string', false, 1, 28)),
			));
			return_error_data($error);
		}
		if ( post_var('add_admin') )
		{
			$this->pbx_admin_ary = $this->request_vars($this->pbx_admin_ary);
			if ( $this->pbx_admin_ary['web_login_password'] === $this->pbx_admin_ary['web_login_password_confirm'] )
			{
				$ct_bean = new contactbean();
				$ct_bean->custId = $user->data['cust_id'];
				$ct_bean->acctId = $user->data['acct_id'];
				$ct_bean->contactTypeId = CONTACT_PBX_ADMIN;
				$ct_bean->firstName = $this->pbx_admin_ary['firstname'];
				$ct_bean->lastName = $this->pbx_admin_ary['lastname'];
				$ct_bean->phoneNum = $this->pbx_admin_ary['phone_num'];
				$ct_bean->webLogin = $this->pbx_admin_ary['web_login'];
				$ct_bean->webLoginPassword = $this->pbx_admin_ary['web_login_password'];

				$status = 'billing3';
				$result = $soap->send(ADD_ACCT_CONTACT, array($ct_bean), $status);
				confirmation_box($status, 'ADMIN_ADDED');
				if ( $status['error'] )
				{
					$template->assign_vars(array(
						'ADD_EDIT'	=> 'add',
						'EDIT_TYPE'	=> 'add_edit_pbx_admin',
					));
				}
			}
			else
			{
				$this->pbx_admin_ary['web_login_password'] = '';
				$this->pbx_admin_ary['web_login_password_confirm'] = '';
				$this->display_vars($this->pbx_admin_ary);
				confirmation_box(array('status' => '', 'error_message' => $user->lang['PASSWD_MISMATCH']), 'PASSWD_MISMATCH');
				
				$template->assign_vars(array(
					'ADD_EDIT'	=> 'add',
					'EDIT_TYPE'	=> 'add_edit_pbx_admin',
				));
			}
		}
		else if ( post_var('edit_admin') )
		{
			$this->pbx_admin_ary = $this->request_vars($this->pbx_admin_ary);
			if ( $this->pbx_admin_ary['web_login_password'] === $this->pbx_admin_ary['web_login_password_confirm'] )
			{
				$ct_bean = new contactbean();
				$ct_bean->contId = request_var('action_cont_id', -1);
				$ct_bean->custId = $user->data['cust_id'];
				$ct_bean->acctId = $user->data['acct_id'];
				$ct_bean->contactTypeId = CONTACT_PBX_ADMIN;
				$ct_bean->firstName = $this->pbx_admin_ary['firstname'];
				$ct_bean->lastName = $this->pbx_admin_ary['lastname'];
				$ct_bean->phoneNum = $this->pbx_admin_ary['phone_num'];
				$ct_bean->webLogin = $this->pbx_admin_ary['web_login'];
				$ct_bean->webLoginPassword = $this->pbx_admin_ary['web_login_password'];

				$status = 'billing3';
				$result = $soap->send(UPDATE_ACCT_CONTACT, array($ct_bean), $status);
				confirmation_box($status, 'ADMIN_SAVED');
				if ( $status['error'] )
				{
					$template->assign_vars(array(
						'ADD_EDIT'	=> 'add',
						'EDIT_TYPE'	=> 'add_edit_pbx_admin',
					));
				}
			}
			else
			{
				$this->pbx_admin_ary['web_login_password'] = '';
				$this->pbx_admin_ary['web_login_password_confirm'] = '';
				$this->display_vars($this->pbx_admin_ary);
				confirmation_box(array('status' => '', 'error_message' => $user->lang['PASSWD_MISMATCH']), 'PASSWD_MISMATCH');
				
				$template->assign_vars(array(
					'ADD_EDIT'	=> 'add',
					'EDIT_TYPE'	=> 'add_edit_pbx_admin',
				));
			}
		}
		
		switch ($action)
		{
			case 'delete':
				$del_id = request_var('action_cont_id', -1);
				$del_user = request_var('action_user_id', '');
				if ( $del_user != $user->data['username'] )
				{
					$status = 'billing';
					$result = $soap->send(DELETE_CONTACT, array($del_id), $status);
					confirmation_box($status, 'ADMIN_DELETED');
				}
				else
				{
					confirmation_box(array('status' => '', 'error_message' => $user->lang['DELETE_SELF']), 'DELETE_SELF');
				}
				break;
			case 'edit':
				$cont_id = request_var('action_cont_id', -1);
				$status = 'billing3';
				$result = $soap->send(GET_ACCT_CONTACT, array($user->data['acct_id']), $status);
				foreach ($result as $row) 
				{
					if ($row['cont_id'] == $cont_id )
					{
						$this->display_vars($row);
						$template->assign_vars(array(
							'WEB_LOGIN_PASSWORD_CONFIRM' => $row['web_login_password'],
							'ADD_EDIT'	=> 'edit',
							'EDIT_TYPE'	=> 'add_edit_pbx_admin',
						));
						break;
					}
				}
			default:
					
				break;
		}

		$status = 'billing3';
		$result = $soap->send(GET_ACCT_CONTACT, array($user->data['acct_id']), $status);
		foreach ($result as $row) 
		{
			if ($row['contact_type_id'] == CONTACT_PBX_ADMIN && $row['acct_id'] == $user->data['acct_id'] )
			{
				$this->display_vars($row, 'pbx_admin');
			}
		}
		
		(!isset($s_hidden_fields))?$s_hidden_fields='':'';
		$s_hidden_fields = build_hidden_fields(array(
			'action_cont_id'	=> $cont_id,
			'action_user_id'	=> '',
			'action'			=> '',
		));
		
		$template->assign_vars(array(
			'U_ACTION'			=> $this->u_action,
			'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
		));
	}
	
	function display_vars($var_array = array(), $block = '')
	{
		global $template;
		
		if ( sizeof($var_array) )
		{
			if (strlen($block) != 0)
			{
				$block_ary = array();
				foreach ($var_array as $key => $value) {
						$block_ary[strtoupper($key)] = $value;
				}
				$template->assign_block_vars($block, $block_ary);
			}
			else 
			{
				foreach ($var_array as $key => $value) {
					$template->assign_vars(array(
						strtoupper($key)	=> $value
					));
				}
			}
		}
	}
	
	function request_vars($var_array = array())
	{
		if ( sizeof($var_array) )
		{
			foreach ($var_array as $key => $default)
			{
				$mb_string = false;
				if (is_array($default))
				{
					$mb_string = $default[1];
					$default = $default[0];
				}
	
				$data[$key] = request_var($key, $default, $mb_string);
	
				if ($mb_string)
				{
					$data[$key] = utf8_normalize_nfc($data[$key]);
				}
			}
			
			return $data;
		}
		return false;
	}
}

class contactbean
{
	public $address1		= '';
	public $address2		= '';
	public $address3		= '';
	public $acctId			= '';
	public $subscriberId	= '';
	public $city			= '';
	public $company			= '';
	public $contactTypeId	= '';
	public $contId			= '';
	public $country			= '';
	public $custId			= '';
	public $email			= '';
	public $faxNum			= '';
	public $firstName		= '';
	public $lastName		= '';
	public $misc			= '';
	public $mobileNum		= '';
	public $phoneNum		= '';
	public $postal			= '';
	public $state			= '';
	public $title			= '';
	public $webLogin		= '';
	public $webLoginPassword= '';
}

?>