<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: company_acc_codes.php,v 1.1 2010/03/12 16:39:42 lsmith Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

require_once ($GLOBALS['common_path'] . 'includes/page.php');
class company_access_codes
{
	public $u_action;
	private $access_code_digits = 0;

	function main($id, $mode)
	{
		global $template, $user, $common_path, $phpEx;

		$action	= request_var('action', '');
		require($common_path . 'classes/customerClass.' . $phpEx);
		$customer = new CustomerClass($user->data['cust_id']); 
		if (post_var('validate_data'))
		{
			require($common_path . 'includes/functions_user.' . $phpEx);

			$validate_ary = array(
				'access_code_digits'	=> request_var('access_code_digits', ''),
			);
			$error = validate_data($validate_ary, array(
				'access_code_digits'	=> array(
					array('num', true, 0, 7)),
			));
//			if (  strlen(request_var('access_code_digits', '')) == 0
//			   && strlen(request_var('did', '')) == 0 ) {
//			   	$error[] = "DID_EXT_REQUIRED";
//			}
			return_error_data($error);
		}
		elseif (post_var('validate_add_edit'))
		{
			require($common_path . 'includes/functions_user.' . $phpEx);

			$numDigits = request_var('access_code_digits', '0');
			$validate_ary = array(
				'cust_id'		=> request_var('cust_id', ''),
				'access_code'	=> request_var('access_code', ''),
			);
			$error = validate_data($validate_ary, array(
				'cust_id'		=> array(
					array('string', false, 1, 15)),
				'access_code'		=> array(
					array('string', false, 1, $numDigits)),
			));
			$acc_code = request_var('access_code', '');
			
			if (!$error && 
				((  strlen($acc_code) == 1 && $acc_code != '*' )
			   	 || (strlen($acc_code) != 1 && strlen($acc_code) != $numDigits)
			   	) 
			   ) {
			   	$error[] = 'INVALID_ACCESS_CODE';
			}
			return_error_data($error);
		}
		else
		{
			if ( post_var('update_access_code') )
			{
				$customer->cust_Bean->accessCodeDigits = request_var('access_code_digits', 0);
				$status = $customer->save_customer();
							
				confirmation_box($status, 'ACCESS_CODE_UPDATED');
			}
	
			switch ($action)
			{
				case 'something':	
					break;
				
				default:
					if ( isset($customer->cust_Bean->accessCodeDigits) )
					{
						$this->access_code_digits = $customer->cust_Bean->accessCodeDigits;
					}
					
					$template->assign_vars(array(
						'ACCESS_CODE_DIGITS'	=> $this->access_code_digits,
						'S_ACCESS_CODE'			=> $this->access_code_digits > 0 ? true : false,
					));				
			}
			
			if ( $this->access_code_digits > 0 ) {
				$parms = new SimpleXMLElement('<PageInfo></PageInfo>');
				$parms->addChild('service','billing3');
				$parms->addChild('get',GET_ENT_ACC_CODES); 
				$parms->addChild('single_get',GET_ENT_ACC_CODES);
				$parms->addChild('add',ASSIGN_ENT_ACC_CODE);
				$parms->addChild('edit','');
				$parms->addChild('delete',DELETE_ENT_ACC_CODE);
				$parms->addChild('keyfield','CUST_ID');
				$parms->addChild('keyfield','ACCESS_CODE');
				$parms->addChild('page_limit',10);
				$searchArray = array(
					'access_code'		=> 'ACCESS_CODE',
				);
				// set up sort array
				$sortArray = array (
					'ACCESS_CODE',
				);
				
				$s_hidden_fields = array(
					'access_code_digits'	=> $this->access_code_digits,
				);
				
				$myPage = new Page($id, $mode, $parms, $this->u_action);
			    $myPage->setSearch('lot_filter', $searchArray );
			    $myPage->setFilter('CUST_ID|=|'.$customer->cust_Bean->custId.'|');
				$myPage->setSorting($sortArray);
				$myPage->processPage(false, $s_hidden_fields);
			}
			
			$template->assign_vars(array(
				'U_ACTION'			=> $this->u_action,
			));
		}
	}
}
?>