<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: dial_plan_maint.php,v 1.11 2011/04/21 03:12:24 hydesun Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class dial_plan_maint
{
	public $u_action;

	function main($id, $mode)
	{
		global $user, $template, $soap, $user_role, $reseller_user, $common_path, $phpEx;
		
		$limit			= request_var('limit', 10);
		$limit			= ($limit > 10) ? 10 : $limit; // don�t let users have a list of over 25
		$start			= request_var('start', 0);
		$sort_key		= request_var('sk', 'clg'); 
		$sort_dir		= request_var('sd', 'clg');
		$status = 'entice';
		$gbl_ary = $soap->send(GET_GBL_PART, array(), $status);
		(sizeof($gbl_ary)?$gbl_part = $gbl_ary[0]['global_partition']: $gbl_part = 0);
		$status = 'entice';
		$vm_rtlst = $soap->send(GET_VOICEMAIL_RTLST, array(), $status, true);
		$vm_rtlst = $vm_rtlst->returnStatus;
		
		$action = request_var('action', '');
		$s_hidden_fields = '';
		$dest_selected = '';
		if (post_var('validate_data'))
		{
			require($common_path . 'includes/functions_user.' . $phpEx);
			$validate_ary = array(
				'dialed_num'			=> request_var('dialed_num',  ''),
				'phone_num'		=> request_var('phone_num', ''),
			);
			$error = validate_data($validate_ary, array(
				'dialed_num'			=> array(
					array('string', false, 1, 32)),
				'phone_num'			=> array(
					array('string', false, 1, 32))
			));
			return_error_data($error);
		}
		else
		{
			confirmation_box ('message','DIAL_PLAN_MESSAGE');
			switch ($action)
			{
				case 'add':
					$dialed_num = request_var('dialed_num', '');
					$phone_num = request_var('phone_num', '');
					$rgId = $user->data['cust_id'];
					$partition = $user->data['cust_id'];
					$dest_selected = request_var('dest_select', '');
					$route_ary = explode('-', $dest_selected);
					$ranpart = request_var('callerid_prefix', '');
					if ( $route_ary[0] != 'P' ) {
						$ranpart = '';
					}
					
					$rqst_ary = array(
						$dialed_num,
						$phone_num,
						$route_ary[1],
						$route_ary[0],
						$rgId,
						'',
						$partition,
						0,
						$ranpart,
						'',
						'',
						''
					);
					$status = 'entice';
					$result = $soap->send(ADD_TRANSLATION, $rqst_ary, $status, false, false, true);
					confirmation_box($status, 'DIAL_PLAN_ADDED');
					
					if ( $status['error'] )
					{
						$template->assign_vars(array(
							'DIALED_NUM'	=> $dialed_num,
							'PHONE_NUMBER'	=> $phone_num,
							'CID_PREFIX'	=> $ranpart
						));
					}
					
					break;
				
				case 'edit':
					$rgId = $user->data['cust_id'];
					$partition = $user->data['cust_id'];
					$key_tag = request_var('key_tag', '');
					$key_tag=str_replace(".","_",$key_tag);
					
					$dialed_num = request_var('dialed_number_'.$key_tag, '');
					$call_type = request_var('call_type_'.$key_tag, '0');
					$noa = request_var('noa_'.$key_tag, '0');
					
//					$dialed_num = request_var('dialed_num', '');
					$phone_num = request_var('phone_num', '');
					$rgId = $user->data['cust_id'];
					$partition = $user->data['cust_id'];
					$dest_selected = request_var('dest_select', '');
					$route_ary = explode('-', $dest_selected);
					$ranpart = request_var('callerid_prefix', '');
					if ( $route_ary [0] != 'P' ) {
						$ranpart = '';
					}
					
					/* 
					 * public String getTranslationsByDialedNumber(int resellerId, String resellerKey, 
					 * String rgId, 
					 * String dialedNumberBeginsWith, 
					 * String calltype, 
					 * String noa, 
					 * String partition, 
					 * String userId)
					 */
					$get_ary = array(
						$rgId,
						$dialed_num,
						$call_type,
						$noa,
						$partition
					);
					$status = 'entice';
					$result = $soap->send('getTranslationsByDialedNumber', $get_ary, $status, false, true, true);
					
					if ( !$result->error ) { 
						$row = $result->xpath("//row[CALL_TYPE = \"$call_type\" and NOA = \"$noa\"]");
						$row[0]->ROUTE_LIST = $route_ary[1];
						$row[0]->ROUTE_TYPE = $route_ary[0];
						$row[0]->RAN_PARTITION = $ranpart;
						$row[0]->DIALED_NUMBER = $dialed_num;
						$row[0]->PARTITION = $partition;
						$row[0]->TRANSLATED_NUMBER = $phone_num;
						$xmlTrans = "<EnticeRequest><data>".$row[0]->asXML()."</data></EnticeRequest>";
						
						/*updateTranslation(int resellerId, String resellerKey, 
						 * int rgId, 
						 * int callType, 
						 * String noa, 
						 * String dialedNumber, 
						 * String partition, 
						 * String xmlTranslation, 
						 * String userId)
						 */
	            		$update_ary = array (
							$rgId,
							$call_type,
							$noa,
							$dialed_num,
							$partition,
							$xmlTrans
	            		);
						
						$status = 'entice';
						$result = $soap->send('updateTranslation', $update_ary, $status, false, false, true);
					}
					else {
						$status = array();
						$status['error'] = true;
						$status['error_message'] = (string)$result->error->errorMessage;
						$status['error_number'] = (string)$result->error->errorNumber;
					}
					confirmation_box($status, 'DIAL_PLAN_UPDATED');
					
					if ( $status['error'] ) {
						$template->assign_vars( array (
							'DIALED_NUM'	=> $dialed_num,
							'PHONE_NUMBER'	=> $phone_num,
							'CID_PREFIX'	=> $ranpart
						));
					}
					break;
					
				case 'delete':
					$rgId = $user->data['cust_id'];
					$partition = $user->data['cust_id'];
					$key_tag = request_var('key_tag', '');
					$key_tag=str_replace(".","_",$key_tag);
					$rqst_ary = array(
						$rgId,
						request_var('dialed_number_'.$key_tag, ''),
						request_var('call_type_'.$key_tag, ''),
						request_var('noa_'.$key_tag, ''),
						$partition
					);
					$status = 'entice';
					$result = $soap->send(DELETE_TRANSLATION, $rqst_ary, $status, false, false, true);
					confirmation_box($status, 'DIAL_PLAN_DELETED');
					break;
			}
		
		// sort by elements
			$sort_by_text = array(
				'clg'	=> $user->lang['DIALED_NUM'],
				'cld'	=> $user->lang['PHONE_NUM'],
			);
	
		// the keys must match the above sort by. -- the below values must correspond to the soap call/database
			$sort_by_sql = array(
				'clg'		=> 'dialed_number',
				'cld'		=> 'translated_number',
			);
			$s_sort_key = $s_sort_dir = $u_sort_param = '';
			gen_sort_selects($sort_by_text, $sort_key, $sort_dir, $s_sort_key, $s_sort_dir, $u_sort_param);
			$filter = search_results('dialed_number', $start);
			search_options('dialed_number', array(
						'DIAL_PLAN'	=> 'disabled',
						'dialed_number'		=> 'DIALED_NUM',
						'translated_number'	=> 'PHONE_NUM',
						
					));
			$this->u_action = $this->u_action . "&amp;$u_sort_param";
			if ( strtoupper($user_role) == 'PBX' )
			{
				$user_id = $reseller_user;
			}
			else
			{
				$user_id = $user->data['user_id'];	
			}
			$soap_ary = array(
							'partition'		=> $user->data['cust_id'],
	            			'user_id'		=> $user_id,
							'pageNumber'	=> ceil(($start + 1) / $limit), 
							'pageSize'		=> $limit,
							'sortField'		=> $sort_by_sql[$sort_key] . '|' . $sort_dir.'|',
							'filter'		=> $filter,
						);
			
			$status = 'entice';
			$result = $soap->send(GET_TRANS_PAGED, $soap_ary, $status);
			$total_rows = $status['total_rows'];
			foreach ($result as $row)
			{
				$curr_dest = $curr_dest_val = '';
				switch ( strtoupper($row['route_type'] ))
				{
					case 'R':
						if ( $row['route_list'] == $vm_rtlst )
						{
							$curr_dest = $user->lang['VOICEMAIL'];
							$curr_dest_val = 'R-'.$vm_rtlst;
						}
						elseif ( $row['route_list'] == $user->data['cust_id'] )
						{
							$curr_dest = $user->lang['PBX'];
							$curr_dest_val = 'R-'.$user->data['cust_id'];
						}
						break;
					case 'P':
						if ( $row['route_list'] == $gbl_part )
						{
							$curr_dest = $user->lang['PSTN'];
							$curr_dest_val = 'P-'.$gbl_part;
						}
						break;
				}
				$key_tag = $row['p_switch_id'].'_'.$row['partition'].'_'.$row['call_type'].'_'.$row['dialed_number'].'_'.$row['noa'];
				$template->assign_block_vars('dial_plan', array(
					'DIAL_NUM'		=> $row['dialed_number'],
					'TRAN_NUM'		=> $row['translated_number'],
					'RAN_PART'		=> $row['ran_partition'],
					'CURR_DEST'		=> $curr_dest,
					'CURR_DEST_VAL'	=> $curr_dest_val,
					'KEY_TAG'		=> $key_tag
				));
				
				$s_hidden_fields .= build_hidden_fields(array(
					'dialed_number_'.$key_tag	=> $row['dialed_number'],
					'noa_'.$key_tag				=> $row['noa'],
					'call_type_'.$key_tag		=> $row['call_type'],
					'phone_number_'.$key_tag	=> $row['translated_number'],
					'ran_partition_'.$key_tag	=> $row['ran_partition'],
					'curr_dest_'.$key_tag		=> $curr_dest_val
				));
			}
			$s_hidden_fields .= build_hidden_fields(array(
				'action'					=> '',
				'key_tag'					=> ''
			));
							
			
			$template->assign_vars(array(
				'DEST_OPTIONS'		=> $this->gen_destination_options($gbl_part, $vm_rtlst, $dest_selected),
			
				'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
			
				'U_ACTION'			=> $this->u_action,
				'S_SORT_KEY'		=> $s_sort_key,
				'S_SORT_DIR'		=> $s_sort_dir,
				'PAGINATION'		=> generate_pagination($this->u_action, $total_rows, $limit, $start),
				'PAGE_NUMBER'		=> on_page($total_rows, $limit, $start),
				'TOTAL_ROWS'		=> sprintf($user->lang['TOTAL_ROWS'], $total_rows),
			));
		}
	}
	
	function gen_destination_options($gbl_part, $vm_rtlst, $selected = '')
	{
		global $user;
		
		$gbl_part = 'P-'.$gbl_part;
		$vm_rtlst = 'R-'.$vm_rtlst;
		$pbx = 'R-'.$user->data['cust_id'];
		
		$options = '';
		$options .= '<option value="'.$pbx.'" '.(($selected == $pbx)?'selected':'').'>' . $user->lang['PBX'] . "</option>";
		$options .= '<option value="'.$vm_rtlst.'" '.(($selected == $vm_rtlst)?'selected':'').'>' . $user->lang['VOICEMAIL'] . "</option>";
		$options .= '<option value="'.$gbl_part.'" '.(($selected == $gbl_part)?'selected':'').'>' . $user->lang['PSTN'] . "</option>";

		
		
		return $options;
	}
}
?>
