<?php

class bulk_feat_maint
{
	public $u_action;

	function main($id, $mode)
	{
		global $user, $template, $soap, $config;
		$acct_id	= $user->data['acct_id'];
		$cust_id	= $user->data['cust_id'];
		$pbx_role	= $user->data['pbx_role'];
		
		$selected_offering = request_var('feature_offering_id', '');
		$num_type = request_var('num_type', 'ANY');
		$feature_action = request_var('feature_action', 'SUBSCRIBE');
		$feature_name = request_var('feat_name', '');
		
		if ( post_var('subscribe') )
		{
			$subscribers = request_var('subscribers', array(''));
			foreach ( $subscribers as $sub )
			{
				$split = split('_', $sub);
				$xml_ary = array(
					$split[0], // subscriber_id
					$selected_offering,
					$feature_name,
					$split[1], // phone_id
					$split[2], // line_id
					$split[3], // number
				);
				$status = 'billing3';
				$soap->send(BEGIN_SERVICE, $xml_ary, $status, false, false, true);
				confirmation_box($status, 'SERVICE_ADDED', $split[3]);
			}
		}
		else if ( post_var('unsubscribe') )
		{
			$subscribers = request_var('subscribers', array(''));
			foreach ( $subscribers as $sub )
			{
				$split = split('_', $sub);
				$xml_ary = array(
					$split[1], // subscribed_feature_id
				);
				$status = 'billing3';
				$soap->send(END_SERVICE, $xml_ary, $status, false, false, true);
				confirmation_box($status, 'SERVICE_REMOVED', $split[2]);
			}
		}
		
		/* Check for feature offerins and build select list */
		$status = 'billing3';
		$result = $soap->send(GET_FEATURE_OFFERINGS, array($cust_id, $acct_id), $status);
		if ( !sizeof($result) )
		{
			confirmation_box(array('status' => '', 'error_message' => $user->lang['FEATURE_REQUIRED']), 'FEATURE_REQUIRED');
			return;
		}
		
		$offering_options = '';
		foreach ( $result as $feat_off )
		{
			if ( $feat_off['feature_offering_level'] == 1 )
			{
				// If no offering is selected select the first one
				($selected_offering == '') ? $selected_offering=$feat_off['feature_offering_id']:'';
				$selected = '';
				if ($selected_offering == $feat_off['feature_offering_id']) {
					$selected = ' selected="selected"';
					$feature_name = $feat_off['feature_name'];
				}
				$offering_options .= '<option value="'.$feat_off['feature_offering_id'].'"'.$selected.'>'.$feat_off['feature_name'].'</option>';
			}
		}
		
		/* Check for Subscribers and find numbers not subscribed to selected feature offering */
		$limit = 1000;
		
		$filter = '';
		$firstname = request_var('firstname', '');
		if ( strlen($firstname) > 0 )
		{
			$filter .= 'FIRSTNAME|BEGINS_WITH|'.$firstname.'|';
		}
		$lastname = request_var('lastname', '');
		if ( strlen($lastname) > 0 )
		{
			$filter .= 'LASTNAME|BEGINS_WITH|'.$lastname.'|';
		}
		$number = request_var('number', '');
		if ( strlen($number) > 0 )
		{
			$filter .= 'VALUE|BEGINS_WITH|'.$number.'|';
		}
		
		$array = array(
			$cust_id,
			$acct_id,
			1,
			$limit,
			'', //sort field
			$filter, 
		);
		$status = 'billing3';
		$result = $soap->send(GET_SUBSCRIBER_ACCT_ID, $array, $status);
		if ( !sizeof($result) )
		{
			if(isset($config['sip_trunk']) && $config['sip_trunk'] ) {
				confirmation_box(array('status' => '', 'error_message' => $user->lang['SIP_TRUNK_SUBSCRIBERS_REQUIRED']), 'SUBSCRIBERS_REQUIRED');
			}
			else {
				confirmation_box(array('status' => '', 'error_message' => $user->lang['SUBSCRIBERS_REQUIRED']), 'SIP_TRUNK_SUBSCRIBERS_REQUIRED');
			}
			confirmation_box(array('status' => '', 'error_message' => $user->lang['FILTER_TO_SPECIFIC']), 'FILTER_TO_SPECIFIC');
		}
		else
		{
			if ( $status['total_rows'] > $limit )
			{
				$array = array(
					$cust_id,
					$acct_id,
					1,
					$status['total_rows'],
					'', //sort field
					$filter,
				);
				$status = 'billing3';
				$result = $soap->send(GET_SUBSCRIBER_ACCT_ID, $array, $status);
			}
		}
		$subscribers_options = '';
		foreach ( $result as $subscriber_details )
		{
			$services_var = 'services_'.$subscriber_details['subscriber_id'];
			if ( !isset($$services_var) )
			{
				$status = 'billing3';
				$$services_var = $soap->send(GET_ACTIVE_SERVICES, $subscriber_details['subscriber_id'], $status, false, true);
			}
			
			if ( $num_type == "DID" || $num_type == "EXT" )
			{
				if ( strtoupper($subscriber_details['value_type']) != $num_type )
				{
					continue;
				}
			}
			if ( ! $$services_var->xpath('//row[FEATURE_OFFERING_ID = "'.$selected_offering.'" and VIRTUAL_NUMBER = "'.$subscriber_details['value'].'"]') && $feature_action == 'SUBSCRIBE' )
			{
				$subscribers_options .= '<option value="'.$subscriber_details['subscriber_id'].'_'.$subscriber_details['phone_id'].'_'.$subscriber_details['line_id'].'_'.$subscriber_details['value'].'"'.$selected.'>'.$subscriber_details['fullname'].'-'.$subscriber_details['value'].'</option>';
			}
			else if ( $$services_var->xpath('//row[FEATURE_OFFERING_ID = "'.$selected_offering.'" and VIRTUAL_NUMBER = "'.$subscriber_details['value'].'"]') && $feature_action == 'UNSUBSCRIBE' )
			{
				$service = $$services_var->xpath('//row[FEATURE_OFFERING_ID = "'.$selected_offering.'" and VIRTUAL_NUMBER = "'.$subscriber_details['value'].'"]');
				$subscribers_options .= '<option value="'.$subscriber_details['subscriber_id'].'_'.$service[0]->SUBSCRIBED_FEATURE_ID.'_'.$subscriber_details['value'].'"'.$selected.'>'.$subscriber_details['fullname'].'-'.$subscriber_details['value'].'</option>';
			}
		}
		
		$template->assign_vars(array(
			'SIP_TRUNK'             => isset($config['sip_trunk'])?$config['sip_trunk']:false,
			'FEATURE_ACTION'		=> $feature_action,
			'FEATURE_NAME'			=> $feature_name,
			'S_SELECT_FEATURE'		=> $offering_options,
			'S_SELECT_SUB'			=> $subscribers_options,

			'NUM_TYPE'				=> $num_type,
			'FIRSTNAME'				=> $firstname,
			'LASTNAME'				=> $lastname,
			'NUMBER'				=> $number,

			'U_ACTION'				=> $this->u_action,
		));	
	}
}