<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: current_usage.php,v 1.21 2011/03/16 14:56:34 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class current_usage {
	public $u_action;

	function main($id, $mode) {
		global $user, $template, $soap, $config;

		$cust_id = $user->data['cust_id'];
		$acct_id = $user->data['acct_id'];
		$pbx_role	= $user->data['pbx_role'];
		$period = 0;

		$by_ext = request_var('by_ext', false);
		$template->assign_var('BY_EXT', $by_ext);

		if ( $by_ext ) {
			$status = 'billing3';
			$result = $soap->send(GET_PHONE_NUMBERS, array($cust_id, $acct_id), $status, false, true);
		}
		else {
			$page=1;
			$filter='CUST_ID|=|'.$cust_id.'|ACCT_ID|=|'.$acct_id.'|';
			$limit=1000000;
			$array = array(
				$page,
				$limit,
				'', //sort field
				$filter, //filter
			);

			$status = 'billing3';
			$result = $soap->send(GET_SUBSCRIBER_PAGED, $array, $status, false, true);
		}
		$ext_list = array();

		if ( !$result->error ) {
			$result = $result->data->row;
			foreach ($result as $row) {
				if ( $by_ext ) {
					$ext_list["$row->NUMBER"] = $row->SUBSCRIBER_ID;
				}
				else {
					$ext_list["$row->FIRSTNAME $row->LASTNAME"] = $row->USER_ID;
				}
			}
			ksort($ext_list);
		}

		if ( sizeof($ext_list) ) {
			$ext = request_var('ext', '');
			if ($ext == '') {
				$sub_ary = array_keys($ext_list, reset($ext_list));
				$ext = $sub_ary[0];
			}

			if (   $pbx_role == 'pbx_admin' || $pbx_role == 'sip_admin' ) {
				$sub_id = isset($ext_list[$ext])?$ext_list[$ext]: '';
				($sub_id == '')?$sub_id = reset($ext_list):'';
			}
			else {
				$sub_id = $user->data['sub_id'];
			}

			$call_type = request_var('call_type', '');
			($call_type == '')?$call_type = 'all':'';

			$csort_key	= request_var('ck', 'a');
			$csort_dir	= request_var('cd', 'a');
			$climit		= request_var('climit', 100);
			$climit		= ($climit > 100) ? 100 : $climit;
			$cstart		= request_var('cstart', 0);
			$cpage = ceil(($cstart + 1) / $climit);

			$csort_by_text = array(
				'a' => $user->lang['DEFAULT'],
				'b'	=> $user->lang['CLG_NUM'],
				'c'	=> $user->lang['CLD_NUM'],
				'd'	=> $user->lang['AMOUNT'],
				'e'	=> $user->lang['CALL_DIRECTION'],
				'f' => $user->lang['ANSWER_TIME'],
				'g' => $user->lang['DISCONNECT_TIME'],
			);
			$csort_by_sql = array(
				'a'	=> 'user_id',
				'b'	=> 'clg_num',
				'c'	=> 'cld_num',
				'd'	=> 'call_amount',
				'e'	=> 'call_direction',
				'f' => 'answer_time',
				'g' => 'disconnect_time',
			);
			
			$ckeys = array('ck', 'cd');
			$s_csort_key = $s_csort_dir = $u_csort_param = '';
			gen_sort_selects($csort_by_text, $csort_key, $csort_dir, $s_csort_key, $s_csort_dir, $u_csort_param, $ckeys);

			// Searching
			$sfilter = search_results('rcr', $cstart);
			search_options('rcr', array(
				'RATED_CALL_RECORDS'	=> 'disabled',

				'clg_NUM'			=> 'CLG_NUM',
				'cld_num'			=> 'CLD_NUM',
				'call_amount'		=> 'AMOUNT',
				'call_direction'	=> 'CALL_DIRECTION',
			));

			$status = 'billing3';
			$result = $soap->send(GET_BILL_BY_CUST, array($cust_id), $status, false, true);
			$result = $result->data->row;

			$period = request_var('period', 0);
			$rtn = get_billing_period($result->CYCLE_CLOSE_FLAG, $result->CYCLE_CLOSE_DATE, $period);
			$start_time = ($rtn['start_time'])?$rtn['start_time']:'';
			$end_time = ($rtn['end_time'])?$rtn['end_time']:'';

			$pagenum = $cpage;
			$pagesize= $climit;
			$sortfield = $soap->soap_build_orderby(array('ORDER_BY'	=> "{$csort_by_sql[$csort_key]} {$csort_dir}"), '');
			$filter = $sfilter . 'user_id|=|'.$sub_id.'|';

			switch ($call_type) {
				case 'missed':
						$filter .= 'CALL_DIRECTION|=|2|CALL_DURATION|=|0|';
					break;
				case 'in':
						$filter .= 'CALL_DIRECTION|=|2|CALL_DURATION|>=|1|';
					break;
				case 'out':
						$filter .= 'CALL_DIRECTION|=|1|';
					break;
				case 'all':
				default:
			}

			$xml_ary = array(
				$start_time,
				$end_time,
				$pagenum,
				$pagesize,
				$sortfield,
				$filter,
			);

			$status = 'billing3';
			$result = $soap->send(GET_RATED_CALL_RECORDS, $xml_ary, $status, false, true);

			$ctot_cost = $ctot_row = $total_call = $total_conn = 0;
			if (!$result->error) {
				$ctot_row = (int)$result->data->TOTAL_ROWS;
				$ctot_cost = (int)$result->data->TOTAL_COST;
				$result = $result->data->row;
				foreach ($result as $row) {
					$dur_min = sprintf("%02d", floor($row->CALL_DURATION/60));
					$dur_seconds = sprintf("%02d", ($row->CALL_DURATION % 60));
					$rate = amount_convert_to_display(floatval($row->RATE)*60);
					if ( $row->CALL_DIRECTION == 2 && $row->CALL_DURATION == 0 ) {
						$row->CALL_DIRECTION = 0;
					}

					$template->assign_block_vars('ratedcalls', array(
						'CLG_NUM'			=> $row->CLG_NUM,
						'CLD_NUM'			=> $row->CLD_NUM,
						'CLD_AREA_DESC'		=> ((int)$row->CALL_DIRECTION == 1)? $row->CLD_AREA_DESC : $user->lang['INBOUND'],
						'CLD_NOA'			=> isset($user->lang['noa_types'][(int)$row->LINE_CHG_NATURE])?$user->lang['noa_types'][(int)$row->LINE_CHG_NATURE]:$row->LINE_CHG_NATURE,
						'ACC_NUM'			=> ((!$config['show_acc_num_1'] && $row->ACC_NUM == 1) || strlen($row->ACC_NUM) == 0 )? '-' : $row->ACC_NUM,
						'CALL_DIRECTION'	=> $user->lang['call_dir'][(int)$row->CALL_DIRECTION],
						'ANSWER_TIME'		=> date(DISPLAY_DATE_FORMAT, strtotime($row->ANSWER_TIME)),
						'DISCONNECT_TIME'	=> date(DISPLAY_DATE_FORMAT, strtotime($row->DISCONNECT_TIME)),
						'DURATION'			=> $dur_min.":".$dur_seconds,
						'RATE'				=> $rate,
						'CONN_CHRG'			=> amount_convert_to_display($row->CONN_CHRG),
						'CALL_AMOUNT'		=> amount_convert_to_display($row->CALL_AMOUNT),
					));
					$total_conn += floatval($row->CONN_CHRG);
					$total_call += floatval($row->CALL_AMOUNT);
				}
			}

			$template->assign_vars(array(
				'PERIOD'			=> $period,
				'START_DATE'		=> date(DISPLAY_SHORT_DATE_FORMAT, $start_time),
				'END_DATE'			=> date(DISPLAY_SHORT_DATE_FORMAT, $end_time),

				'TOTAL_CALL'		=> amount_convert_to_display($total_call),
				'TOTAL_AMOUNT'		=> amount_convert_to_display($ctot_cost),
				'SHOW_BILLING'		=> isset($config['show_billing'])?$config['show_billing']:true,

				// Sorting
				'S_CSORT_KEY'		=> $s_csort_key,
				'S_CSORT_DIR'		=> $s_csort_dir,

				// pagination
				'PAGINATION'	=> generate_pagination(str_replace('&amp;cstart=' . $cstart, '', $this->u_action . '&amp;period='.$period.'&amp;call_type='.$call_type.'&amp;ext='.$ext.'&amp;climit='.$climit), $ctot_row, $climit, $cstart, true, '', 'cstart'),
				'PAGE_NUMBER'	=> on_page($ctot_row, $climit, $cstart),

				'CALL_TYPE'			=> $call_type,
				'EXT_OPTIONS'		=> $this->gen_ext_options($ext_list, $ext, $pbx_role, $sub_id),
			));
		}
		else {
			confirmation_box(array('status' => '', 'error_message' => $user->lang['EXT_REQUIRED']), 'EXT_REQUIRED');
		}

		$s_hidden_fields = build_hidden_fields(array(
			'period'		=> $period,
		));

		$template->assign_vars(array(
			'S_HIDDEN_FIELDS'	=> $s_hidden_fields,

			'U_ACTION'			=> $this->u_action
		));
	}

	function gen_ext_options($data = array(), $current, $pbx_role, $sub_id) {
		$options = '';
		foreach ($data as $ext => $subscriber) {
			if (  (($pbx_role == 'pbx_user' || $pbx_role == 'sip_user') && $subscriber == $sub_id)
			    || $pbx_role == 'pbx_admin'
			    || $pbx_role == 'sip_admin' ) {
				$options .= '<option value="'.$ext.'" '.(($current == $ext)?'selected':'').'>' . $ext . "</option>";
			}
		}

		return $options;
	}
}
?>