<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: network_features.php,v 1.12 2011/05/27 02:58:17 henryhou Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

class network_features {
	public $u_action;

	function main($id, $mode) {
		global $user, $template, $soap, $config; //, $user_role;
		
		$sub_id = request_var('sub_id', '');
		($sub_id == '')?$sub_id = 0:'';
		$main_number = request_var('main_number', '');
		($main_number == '')? $main_number = 0 : '';
		$cust_id = $user->data['cust_id'];
		
		$action = request_var('action', '');
		$s_hidden_fields = '';
		
		if (isset($config['sip_trunk']) && $config['sip_trunk']) {
			$page = array(
				'SIP_TRUNK_CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
			
			);
		}
		else {
			$page = array(
				'CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
			);
		}
		breadcrumbs($page);
		
		// Ensure we got somebody with a number if not go back to centrex admin
		if (!$main_number || !$sub_id)
		{
			redirect(str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action));
		}
		// If we do persist the data in hidden fields while on this page.
		$s_hidden_fields .= build_hidden_fields(array(
			'sub_id'		=> $sub_id,
			'main_number'	=> $main_number
		));
		
		$acct_id = $user->data['acct_id'];
		$xml = new SimpleXMLElement('<row></row>');
		$xml->addChild('CUST_ID', $cust_id);
		$xml->addChild('ACCT_ID', $acct_id);
		$xml->addChild('filter', "CUST_ID|=|".$cust_id."|ACCT_ID|=|".$acct_id);
		$status = 'billing3';
		$result = $soap->send(GET_FEATURE_OFFERINGS_XML, $xml->asXML(), $status, false, true);
		$result = $result->xpath('//row');
		$name_arr = array();
		foreach ($result as $row) {
			$name_arr[(string)$row->FEATURE_TYPE_ID] = $row->FEATURE_NAME;
		}
		//trigger_error(print_r($result, false));
		
		$soap_user_id = get_soap_user_id();
		
		if ( post_var('acb_save') )
		{
			$feature_status = request_var('acb', 2);
			$send_to = request_var('acb_options', 1);
			
			$status = 'entice';
			$result = $soap->send(CHANGE_FEATURE_ACB2, array($main_number, $feature_status, $send_to, $soap_user_id, $cust_id), $status);
			confirmation_box($status, $name_arr[5] . ' ' . $user->lang['SAVED_ACB']);
		}
		else if ( post_var('cid_display_save') )
		{
			$feature_status = request_var('cid_display', 1);
			
			$status = 'entice';
			$result = $soap->send(CHANGE_FEATURE_CID_DISPLAY2, array($main_number, $feature_status, $soap_user_id, $cust_id), $status);
			confirmation_box($status, $name_arr[7] . ' ' . $user->lang['SAVED_CID_DISPLAY']);
		}
		else if ( post_var('cid_withhold_save') )
		{
			$feature_status = request_var('cid_withhold', 2);
			($feature_status == 1)?$restricted = 'R':$restricted = 'A';
			$cust_id = $user->data['cust_id'];
			
			$status = 'entice';
			$result = $soap->send(CHANGE_FEATURE_CID_WITHHOLD2, array($main_number, $feature_status, $restricted, $soap_user_id, $cust_id), $status);
			confirmation_box($status, $name_arr[6] . ' ' . $user->lang['SAVED_CID_WITHHOLD']);
		}
		else if ( post_var('dnd_save') )
		{
			$feature_status = request_var('dnd', 2);
			
			$status = 'entice';
			$result = $soap->send(CHANGE_FEATURE_DND2, array($main_number, $feature_status, $soap_user_id, $cust_id), $status);
			confirmation_box($status, $name_arr[1] . ' ' . $user->lang['SAVED_DND']);
		}
		else if ( post_var('follow_me_save') )
		{
			$feature_status = request_var('follow_me', 2);
			$follow_me_type = request_var('follow_me_option', 1);
			$follow_me_numbers = request_var('follow_number', array(''));
			// strip empties
			$follow_me_numbers = array_merge(array_filter($follow_me_numbers), array());
			if ( !$follow_me_numbers )
			{
				// If no Numbers set status to disabled
				$feature_status = 2;
			}
			
			$status = 'entice';
			$result = $soap->send(CHANGE_FEATURE_FOLLOW_ME2, array($main_number, $feature_status, $follow_me_type, $follow_me_numbers, $soap_user_id, $cust_id), $status);
			confirmation_box($status, $name_arr[2] . ' ' . $user->lang['SAVED_FOLLOW_ME']);
		}
		else if ( post_var('acf_save') )
		{
			$feature_status = request_var('acf', 2);
			
			$status = 'entice';
			$result = $soap->send(GET_FEATURE_ACF2, array($main_number, $cust_id), $status, false, true);
			$request = new SimpleXMLElement ('<EnticeRequest>'.$result->data->asXML().'</EnticeRequest>');
			$request->data->row->STATUS=$feature_status;
			
			$status = 'entice';
			$result = $soap->send(CHANGE_FEATURE_ACF2, array($main_number, $feature_status, $request->asXML(), $soap_user_id, $cust_id,$sub_id), $status);
			confirmation_box($status, $name_arr[13] . ' ' . $user->lang['SAVED_ACF']);
		}
		else if ( post_var('cf_save') )
		{
			$feature_status = request_var('cf_always', 2);
			$send_to = request_var('cf_always_options', 0);
			$number = request_var('cf_always_num', '');
			( $send_to == 1 && $number == '' )?$send_to = 0 : '';
			
			$always_status = 'entice';
			$always_result = $soap->send(CHANGE_FEATURE_CF_ALWAYS2, array($main_number, $feature_status, $send_to, $number, $soap_user_id, $cust_id), $always_status);
			
			$feature_status = request_var('cf_busy', 2);
			$send_to = request_var('cf_busy_options', 0);
			$number = request_var('cf_busy_num', '');
			( $send_to == 1 && $number == '' )?$send_to = 0 : '';
			
			$busy_status = 'entice';
			$busy_result = $soap->send(CHANGE_FEATURE_CF_BUSY2, array($main_number, $feature_status, $send_to, $number, $soap_user_id, $cust_id), $busy_status);
			
			$feature_status = request_var('cf_na', 2);
			$send_to = request_var('cf_na_options', 0);
			$number = request_var('cf_na_num', '');
			( $send_to == 1 && $number == '' )?$send_to = 0 : '';
			
			$na_status = 'entice';
			$na_result = $soap->send(CHANGE_FEATURE_CF_NA2, array($main_number, $feature_status, $send_to, $number, $soap_user_id, $cust_id), $na_status);
			
			if ( isset($always_result->error) )
			{
				confirmation_box($always_status, $name_arr[3] . ' ' . $user->lang['SAVED_CF']);
			}
			else if ( isset($busy_result->error) )
			{
				confirmation_box($busy_status, $name_arr[3] . ' ' . $user->lang['SAVED_CF']);
			}
			else if ( isset($na_result->error) )
			{
				confirmation_box($na_status, $name_arr[3] . ' ' . $user->lang['SAVED_CF']);
			}
			else
			{
				confirmation_box($always_status, $name_arr[3] . ' ' . $user->lang['SAVED_CF']);				
			}
		}
		
		switch ($action)
		{
			default:
				$acb = $cid_display = $cid_withhold = $cf_always = $cf_busy = $cf_na = $acf = $color_ring = $dnd = $follow_me = false;
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_CID_DISPLAY2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result= $result->data->row;
					$cid_display = true;
					$template->assign_vars(array(
						'CID_DISPLAY'				=> true,
						'CID_NAME'					=> $name_arr[7],
						'CID_DISPLAY_STATUS_SELECT'	=> $this->gen_network_feature_status('cid_display', $result->STATUS),
						'CID_DISPLAY_STATUS'		=> $result->STATUS,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_CID_WITHHOLD2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result= $result->data->row;
					$cid_withhold = true;
					$template->assign_vars(array(
						'CID_WITHHOLD'					=> true,
						'CID_WITHHOLD_NAME'				=> $name_arr[6],
						'CID_WITHHOLD_STATUS_SELECT'	=> $this->gen_network_feature_status('cid_withhold', $result->STATUS),
						'CID_WITHHOLD_STATUS'			=> $result->STATUS,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_DND2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result= $result->data->row;
					$dnd = true;
					$template->assign_vars(array(
						'DND'				=> true,
						'DND_NAME'			=> $name_arr[1],
						'DND_STATUS_SELECT'	=> $this->gen_network_feature_status('dnd', $result->STATUS),
						'DND_STATUS'		=> $result->STATUS,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_ACB2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result = $result->data->row;
					$acb = true;
					$template->assign_vars(array(
						'ACB'				=> true,
						'ACB_NAME'			=> $name_arr[5],
						'ACB_STATUS_SELECT'	=> $this->gen_network_feature_status('acb', $result->STATUS, 'onchange="show_hide_option_box(\'acb\', \'acb_options\');"'),
						'ACB_STATUS'		=> $result->STATUS,
						'ACB_SEND_TO'		=> $result->parm->SEND_TO,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_CF_ALWAYS2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result = $result->data->row;
					$cf_always = true;
					$template->assign_vars(array(
						'CF_ALWAYS'					=> true,
						'CF_NAME'					=> $name_arr[3],
						'CF_ALWAYS_STATUS_SELECT'	=> $this->gen_network_feature_status('cf_always', $result->STATUS, 'onchange="show_hide_option_box(\'cf_always\', \'cf_always_options\', \'cf_always_num_box\');"'),
						'CF_ALWAYS_NUM'				=> $result->parm->FNUMBER,
						'CF_ALWAYS_STATUS'			=> $result->STATUS,
						'CF_ALWAYS_SEND_TO'			=> $result->parm->SEND_TO,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_CF_BUSY2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result = $result->data->row;
					$cf_busy = true;
					$template->assign_vars(array(
						'CF_BUSY'					=> true,
						'CF_NAME'					=> $name_arr[3],
						'CF_BUSY_STATUS_SELECT'		=> $this->gen_network_feature_status('cf_busy', $result->STATUS, 'onchange="show_hide_option_box(\'cf_busy\', \'cf_busy_options\', \'cf_busy_num_box\');"'),
						'CF_BUSY_NUM'				=> $result->parm->FNUMBER,
						'CF_BUSY_STATUS'			=> $result->STATUS,
						'CF_BUSY_SEND_TO'			=> $result->parm->SEND_TO,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_CF_NA2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result = $result->data->row;
					$cf_na = true;
					$template->assign_vars(array(
						'CF_NA'		=> true,
						'CF_NAME'				=> $name_arr[3],
						'CF_NA_STATUS_SELECT'	=> $this->gen_network_feature_status('cf_na', $result->STATUS, 'onchange="show_hide_option_box(\'cf_na\', \'cf_na_options\', \'cf_na_num_box\');"'),
						'CF_NA_NUM'				=> $result->parm->FNUMBER,
						'CF_NA_STATUS'			=> $result->STATUS,
						'CF_NA_SEND_TO'			=> $result->parm->SEND_TO,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_ACF2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result = $result->data->row;
					$acf = true;
					$template->assign_vars(array(
						'ACF'		=> true,
						'ACF_NAME'			=> $name_arr[13],
						'ACF_STATUS_SELECT'	=> $this->gen_network_feature_status('acf', $result->STATUS, ''),
						'ACF_STATUS'		=> $result->STATUS,
						'U_ACF'				=> str_replace('mode=' . $mode, 'mode=call_forwarding', $this->u_action) . '&amp;did=' . $main_number. '&amp;sub_id=' . $sub_id,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_FOLLOW_ME2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					$result = $result->data->row;
					$parm = $result->parm;
					foreach ($parm as $element) {
						$template->assign_var('FOLLOW_NUMBER'.$element->FPARM, $element->FNUMBER);
					}

					$follow_me = true;
					$template->assign_vars(array(
						'FOLLOW_ME'					=> true,
						'FOLLOW_NAME'				=> $name_arr[2],
						'FOLLOW_ME_STATUS_SELECT'	=> $this->gen_network_feature_status('follow_me', $result->STATUS, 'onchange="show_hide_option_box(\'follow_me\', \'follow_me_options\');show_hide_option_box(\'follow_me\', \'follow_me_title\');"'),
						'FOLLOW_ME_STATUS'			=> $result->STATUS,
						'FOLLOW_ME_TYPE'			=> $result->FOLLOW_ME_FEATURE_TYPE,
					));
				}
				
				$status = 'entice';
				$result = $soap->send(GET_FEATURE_COLOR_RING2, array($main_number, $cust_id), $status, false, true);
				if (!$result->error && $result->data->row->STATUS != 0)
				{
					// Parse info
					$color_ring = true;
					$template->assign_vars(array(
						'COLOR_RING'		=> true,
						'CF_NAME'			=> $name_arr[14],
					));
				}
				
				if ( !($acb || $cid_display || $cid_withhold || $cf_always || $cf_busy || $cf_na || $acf || $color_ring || $dnd || $follow_me) )
				{
					confirmation_box(array('status' => '', 'error_message' => $user->lang['MUST_SUBSCRIBE']), 'MUST_SUBSCRIBE');
				}
				break;
		}
		
		$s_hidden_fields .= build_hidden_fields(array(
			'action'					=> '',
		));
						
		$template->assign_vars(array(
			'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
		
			'MAIN_NUMBER'		=> $main_number,
			'U_ACTION'			=> $this->u_action
		));
	}
	
	function gen_network_feature_status($id = '', $current_state = 0, $extra_html = '')
	{
		global $user;
	
		$states = array(
			1 => $user->lang['ENABLED'],
			2 => $user->lang['DISABLED'],
		);
	
		$name = ($id != '')? $id : 'net_feat_status';
	
		$select = '<select id="' . $name . '" name="' . $name . '" ' . $extra_html . '>';
		for ($i = 1; $i < 3; $i++)
		{
			$selected = ($current_state == $i) ? ' selected="selected"' : '';
			$select .= '<option value="' . $i . '"' . $selected . '>' . $states[$i] . '</option>';
		}
		$select .= '</select>';
	
		return $select;
	}

}
?>