<?php
/**
*
* common [English]
*
* @author Lance Smith
* @package reseller modules
* @version $Id: line_maintenance.php,v 1.111 2011/05/22 10:21:36 iharel Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

/**
 * @ignore
 */
if (!defined('IN_ENTICE')) {
	exit();
}

/**
 * Class Includes
 */
require_once ($GLOBALS['common_path'] . 'classes/Xml_Sort.php');
require_once ($GLOBALS['common_path'] . 'classes/ContactClass.php');
require_once ($GLOBALS['common_path'] . 'classes/LocaleClass.php');

/**
* reseller_edit_subscriber
* Reseller Edit Subscriber
* @package reseller
*/
class line_maintenance {
	public $u_action;
	public $module_class;

	private $allowed_feature_phone_type = array('cisco7931', 'cisco7941', 'cisco7961', 'cisco7970');

	function main($id, $mode) {
		global $soap, $template, $user, $common_path, $web_common_path, $config, $phpEx;

		require($common_path . 'includes/functions_user.' . $phpEx);

		$s_hidden_fields = array();

		if (request_var('assign_features', false)) {
			$assign_features = 'true';
		}
		else {
			$assign_features = 'false';
		}

		$template->assign_vars(array(
			'EXPOSE_PIN'			 => isset($config['expose_pin'])?$config['expose_pin']:true,
		));

		$sub_id			= request_var('sub_id', '');
		$did_id			= preg_replace( '/[\D]/', '', request_var('did', ''));
		$ext_id			= request_var('ext', '');
		$phone_id		= request_var('phone_id', 0);
		$mac_address	= request_var('mac_address', '');
		$phone_type		= request_var('phone_type', '');
		$pin_id			= request_var('pin', '');
		$line_var_id	= request_var('line_id', 0);
		$vm_offering	= request_var('voicemail_subs', 0);
		$ep_alias		= request_var('ep_alias', '');
		$action			= request_var('action', '');

		// Page Setup defines pbx settings or Retail settings
		$pbx_role = "";
		$sip_trunk = false;
		$access_code_digits = 0;

		if ( isset($user->data['is_pbx']) && $user->data['is_pbx'] ) {
			$cust_id = $user->data['cust_id'];
			$acct_id = $user->data['acct_id'];
			$act_service_type = $user->data['service_type'];
			$fee_id	 = $user->data['feeplan_id'];
			$pbx_role = $user->data['pbx_role'];

			if ( strtoupper(substr($pbx_role, 0, 3)) == 'SIP' ) {
				$sip_trunk = true;
			}

			$build_back_link = $this->u_action . "&amp;sub_id=$sub_id";

			$status = 'billing';
			$result = $soap->send('getCustomerById', array($cust_id), $status);
			if ( isset($result[0]['access_code_digits'])) {
				$access_code_digits = $result[0]['access_code_digits'];
			}
			else {
				$access_code_digits = 0;
			}
			$template->assign_var('ACCESS_CODE_DIGITS', $access_code_digits);
			if ( $sip_trunk ) {
				$page = array(
					'SIP_TRUNK_CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
				);
			}
			else {
				$page = array(
					'CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
				);
			}
		}
		else {
			$user->data['is_pbx'] = false;
			$cust_id = request_var('cust_id', '');
			$acct_id = request_var('acct_id', 0);
			$fee_id	 = request_var('fee_id', 0);
			$act_service_type = request_var('service_type', -1);

			$build_back_link = $this->u_action . "&amp;sub_id=$sub_id&amp;cust_id=$cust_id&amp;acct_id=$acct_id&amp;fee_id=$fee_id".'&amp;service_type='.$act_service_type;

			$page = array(
				'AGENTS'			=> str_replace(array('i=' . $id, 'mode=' . $mode), array('i=subscriber', 'mode=maintain'), $this->u_action),
				'SUBSCRIBERS'		=> str_replace(array('i=' . $id, 'mode=' . $mode), array('i=subscriber', 'mode=maintain'), $this->u_action) . '&amp;action=details'. '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id . '&amp;fee_id=' . $fee_id . '&amp;service_type=' . $act_service_type,
			);
			$this->u_action .= '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id . '&amp;fee_id=' . $fee_id . '&amp;service_type=' . $act_service_type;
		}
		
		breadcrumbs($page);
		$this->u_action .= '&amp;sub_id=' . $sub_id;
		if ( strspn($action, 'ani', 0, 3) == 3 ) {
			require($web_common_path . '/classes/aniClass.php');
			$aniC = new aniClass($this->u_action, $cust_id, $acct_id);
			$aniC->doDisplay($sub_id, $action);
			return;
		}
		
		// Begin data processing
		if ( strlen($pin_id) == 0 ) {
			$pin_id		= request_var('ep_pin', '');
		}
		if ( strlen($phone_type) == 0 ) {
			$phone_type = $config['phone_type'];
        }
        if (  strlen($ep_alias) == 0 && $sip_trunk ) {
			if ( strlen ( $did_id ) > 0 ) {
				$ep_alias = $did_id;
			}
			else {
            	$ep_alias = $user->data['cust_id'] . '_' . $ext_id;
			}
        }
		$status_serv = 'billing3';
		$services = $soap->send(GET_SERVICES, $sub_id, $status_serv, false, true);

		$reques_ary = array (
			'access_code'			=> '',
			'dial_local'			=> false,
			'dial_mobile'			=> false,
			'dial_domestic'			=> false,
			'dial_international'	=> false
		);
		$ajax_update_access_code = post_var('ajax_update_access_code');

		$submit_parms = post_var('submit_params');
		if (post_var('param_ajax') || $submit_parms) {
			$phone_id = request_var('phone_id', -1);
			$line_id = request_var('line_id', 0);

			if ($submit_parms) {
				$update_xml = new SimpleXMLElement("<EnticeRequest></EnticeRequest>");
				$update_data = $update_xml->addChild('data');
				$update_phone = $update_data->addChild('phone');
					$update_phone->addChild('RESELLER_ID', $user->data['rsid']);
					$update_phone->addChild('CARD_ID', $sub_id);
					$update_phone->addChild('PHONE_ID', $phone_id);
			}

			$status = 'autoprovisioning';
			$result = $soap->send('getPhone', array($sub_id, $phone_id), $status, false, true);
			$parms = $result->xpath("//LINE[@lineId=$line_id]/FEATURE[SCOPE=\"User\"]");
			$html_code = '';
			if ( $parms ) {
				$html_code .= '<dl>';

				foreach ($parms as $feature) {
					$html_code .= '<dt>'.$feature->PROMPT.'</dt>';
					$html_code .= '<dd>';

					$feat_name = $feature['name'];
					$feat_val = $feature['value'];

					if ($submit_parms) {
						$new_feat = $update_phone->addChild('FEATURE');
							$new_feat->addAttribute('name', $feat_name);
							$new_val = request_var("$feat_name", '');
							if ( $new_val != '' ) {
								$feat_val = $new_val;
							}
							$new_feat->addAttribute('value', $feat_val);
							$new_feat->addAttribute('lineId', $line_id);
					}
					if ($feat_val == '') {
						$feat_val = $feature->DEFAULT_VALUE;
					}
					switch ($feature->INPUT_TYPE) {
						case 'select':
							$html_code .= '<select id="'.$feat_name.'" name="'.$feat_name.'">';
							$options = split('\|', $feature->PERMITTED_VALUES);
							for ( $ct = 0; $ct < sizeof($options); $ct += 2) {
								$html_code .= '<option value="'.$options[$ct+1].'" '.(($options[$ct+1]==$feat_val)?' selected="selected"': '').'>'.$options[$ct].'</option>';
							}
							$options = array();
							$html_code .= '</select>';
							break;
						case 'text':
						default:
							$html_code .= '<input type="text" class="inputbox" name="'.$feat_name.'" id="'.$feat_name.'" value="'.$feat_val.'" />';
							break;
					}
					$html_code .= '</dd>';
				}
				$html_code .= '</dl>';

				if ($submit_parms) {
					$status = 'autoprovisioning';
					$result = $soap->send('updatePhone', array($update_xml->asXML()), $status, false, true);
					confirmation_box($status, 'PHONE_PARM_UPDATED');
				}
			}
			else {
				if ( !$line_id ) {
					$template->assign_var('NO_SUBMIT', true);
					confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_PARAMS_TO_UPDATE']), 'NO_PARAMS_TO_UPDATE');
				}
			}

			// Do update PIN if on a line, just in case they changed it.
			if ( $line_id ) {
				$ep_pin = request_var('ep_pin', '');

				$xml_ary = array(
					$sub_id,
					$phone_id,
					$line_var_id,
				);
				$status = 'billing3';
				$phone_xml = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);
				if (isset($phone_xml->data->row->EP_PIN)) {
					$cur_pin=(string)$phone_xml->data->row->EP_PIN;
					$phone_xml->data->row->EP_PIN=$ep_pin;

					if ($submit_parms && $cur_pin != $ep_pin) {
						$xml = $phone_xml->asXML();
						$xml = str_replace('EnticeResponse', 'EnticeRequest', $xml);
						$status = 'billing3';
						$result = $soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml), $status, false, false, true);
						confirmation_box($status, 'LINE_PIN_UPDATED');
					}
					$template->assign_vars(array(
						'EP_ALIAS'		=> $phone_xml->data->row->EP_ALIAS,
						'EP_PIN'		=> $ep_pin,
						'OLD_PIN'		=> $cur_pin,
					));
				}
			}

			$template->assign_vars(array(
				'PHONE_PARMS_AJAX'	=> true,
				'VALUE_LIST'		=> $html_code,

				'PHONE_ID'			=> $phone_id,
				'LINE_ID'			=> $line_id,

				'U_ACTION'			=> $this->u_action,
			));

			return;
		}
		else if (post_var('delete_access_code')) {
			$del_acc_code = request_var('code_to_del', '');

			if ( strlen($del_acc_code) > 0 ) {
				$acces_code_xml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
				$xmldata = $acces_code_xml->addChild('data');
				$row = $xmldata->addChild('row');
				$row->addChild('SUBSCRIBER_ID', $sub_id);
				$row->addChild('ACCESS_CODE', $del_acc_code);

				$status = 'billing3';
				$soap->send(DELETE_ACCESS_CODE, $acces_code_xml->asXML(), $status, false, false, true);
			}

			confirmation_box($status, $user->lang['ACCESS_CODE_DELETED']);
			$ajax_update_access_code = true;
		}
		else if (post_var('add_access_code')) {
			$reques_ary = request_vars($reques_ary);

			$status = 'billing3';
			$result = $soap->send(GET_ENT_ACC_CODES, '<EnticeRequest><data><row><filter>CUST_ID|=|'.$cust_id.'|ACCESS_CODE|=|'.$reques_ary['access_code'].'</filter></row></data></EnticeRequest>', $status, false, true);
			$cpyAcc = $result->xpath('//row[1]');

			$acces_code_xml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
			$xmldata = $acces_code_xml->addChild('data');
			$row = $xmldata->addChild('row');
			$row->addChild('SUBSCRIBER_ID', $sub_id);
			$row->addChild('ACCESS_CODE', $reques_ary['access_code']);
			$row->addChild('CAN_DIAL_LOCAL', $cpyAcc[0]->CAN_DIAL_LOCAL);
			$row->addChild('CAN_DIAL_MOBILE', $cpyAcc[0]->CAN_DIAL_MOBILE);
			$row->addChild('CAN_DIAL_DOMESTIC', $cpyAcc[0]->CAN_DIAL_DOMESTIC);
			$row->addChild('CAN_DIAL_INTERNATIONAL', $cpyAcc[0]->CAN_DIAL_INTERNATIONAL);

			$status = 'billing3';
			$soap->send(ADD_ACCESS_CODE, $acces_code_xml->asXML(), $status, false, false, true);

			confirmation_box($status, $user->lang['ACCESS_CODE_ADDED']);
			$ajax_update_access_code = true;
		}

		if (post_var('ajax_update_status')) {
			$status = 'billing3';
			$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, $sub_id, $status, false, true);

			if (sizeof($result->data->row)) {
				$row = $result->data->row;
				if ( $act_service_type == 2 ) {
					$new_amount = amount_convert_to_display((int)$row->LIMIT - (int)$row->BALANCE_REF);
					$balance = 	  amount_convert_to_display($row->LIMIT);
				}
				elseif ( $act_service_type == 1 ) {
					$new_amount = amount_convert_to_display($row->BALANCE_REF);
					$balance = amount_convert_to_display($row->BALANCE);
				}
			}
			else {
				$new_amount = $user->lang['AMT_ERR'];
				$balance = $user->lang['AMT_ERR'];
			}

			$template->assign_vars(array(
				'JQUERY_AJAX'	=> true,
				'RETURN_DATA'	=> $new_amount.'~'.$balance
			));
			return;
		}
		else if ($ajax_update_access_code ) {
			$return_html =
			'<!-- INCLUDECOMMON confirmation_box.html -->
			<!-- IF PBX_ROLE == "pbx_admin" or PBX_ROLE == "sip_admin" -->
				<p style="float: right">
					<input type="button" name="add_access_code" value="{L_ADD_ACCESS_CODE}" class="button2 ui-corner-all" onclick="$(\'#add_access_code\').dialog(\'open\');" />
				</p>
			<!-- ENDIF -->
			<h3 style="padding-left: 10px;">{L_ACCESS_CODES}</h3>
			<div style="text-align: center">{L_ACCESS_LEN_NOTE} '.$access_code_digits.'</div>
			<table class="ui-corner-all" style="font-size: .8em;">
				<tr>
					<th>{L_ACCESS_CODE}</th>
					<th>{L_DESCRIPTION}</th>
					<th>{L_DIAL_LOCAL}</th>
					<th>{L_DIAL_MOBILE}</th>
					<th>{L_DIAL_DOMESTIC}</th>
					<th>{L_DIAL_INTERNATIONAL}</th>
					<!-- IF PBX_ROLE == "pbx_admin" or PBX_ROLE == "sip_admin" --><th>{L_ACTION}</th><!-- ENDIF -->
				</tr>';

			$status = 'billing3';
			$result = $soap->send(GET_ACCESS_CODES, 'SUBSCRIBER_ID|=|'.$sub_id.'|', $status, false, false);

			if (sizeof($result)) {
				$bgct = 2;
				foreach ($result as $row) {
					$tmp_str = '<tr class="bg'.$bgct.'">';
						$tmp_str .= '<td style="text-align:center">'.$row['access_code'].'</td>';
						$tmp_str .= '<td style="text-align:center">'.$row['info'].'</td>';
						$tmp_str .= '<td style="text-align:center">'.(($row['can_dial_local']) ? '√' : '').'</td>';
						$tmp_str .= '<td style="text-align:center">'.(($row['can_dial_mobile']) ? '√' : '').'</td>';
						$tmp_str .= '<td style="text-align:center">'.(($row['can_dial_domestic']) ? '√' : '').'</td>';
						$tmp_str .= '<td style="text-align:center">'.(($row['can_dial_international']) ? '√' : '').'</td>';
						$tmp_str .= '<!-- IF PBX_ROLE == "pbx_admin" or PBX_ROLE == "sip_admin" --><td style="text-align:center">
						<a href="" onclick="$(\'#access_code\').append(\'<option value=\\\''.$row['access_code'].'\\\'>'.$row['access_code'].'-'.$row['info'].'</option>\'); $(\'#access_code_div\').load(\''.$this->u_action.'\',{\'delete_access_code\':\'true\', \'code_to_del\':\''.$row['access_code'].'\'}); return false;">{L_DELETE}</a>
						</td><!-- ENDIF -->';
					$tmp_str .= '</tr>';
					$return_html .= $tmp_str;
					$bgct = ($bgct == 2)?1:$bgct++;
				}
			}
			else {
				$return_html = $return_html .
				'<tr>
					<td colspan="5">{L_NO_ACCESS_CODES}</td>
				</tr>';
			}
			$return_html = $return_html . '</table>';

			$return_html = $template->displayString($return_html, false);

			$template->assign_vars(array(
				'JQUERY_AJAX'	=> true,
				'RETURN_DATA'	=> $return_html,
			));
			return ;
		}
		else if (post_var('add_phone')) {
			try {
				$xml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
				$xmldata = $xml->addChild('data');
				$row = $xmldata->addChild('row');
					$row->addChild('SUBSCRIBER_ID', $sub_id);
					$row->addChild('PHONE_ID', $phone_id);
					$row->addChild('MAC_ADDR', $mac_address);
					$row->addChild('PHONE_TYPE', $phone_type);
					$row->addChild('ASSIGN_FEATURES', $assign_features);
					$row->addChild('LINE_ID', 1);
					$row->addChild('EP_ALIAS', $ep_alias);
					$row->addChild('EP_PIN', $pin_id);
					if ( strlen($ext_id) ) {
						$number = $row->addChild('NUMBER', $ext_id);
						$number->addAttribute('type', 'EXT');
						$number->addAttribute('main', 'true');
						if ($vm_offering) {
							$number->addAttribute('vmOfferingId', $vm_offering);
							$number->addAttribute('mailbox', $ext_id);
						}
						if ( strlen($did_id) ) {
							$number = $row->addChild('NUMBER', $did_id);
							$number->addAttribute('type', 'DID');
							$number->addAttribute('main', 'false');
							if ($vm_offering) {
								$number->addAttribute('vmOfferingId', $vm_offering);
								$number->addAttribute('mailbox', $ext_id);
							}
						}
					}
					elseif ( strlen($did_id) ) {
						$number = $row->addChild('NUMBER', $did_id);
						$number->addAttribute('type', 'DID');
						$number->addAttribute('main', 'true');
						if ($vm_offering) {
							$number->addAttribute('vmOfferingId', $vm_offering);
							$number->addAttribute('mailbox', $did_id);
						}
					}
					else {
						if ( $user->data['is_pbx'] ) {
							throw new Exception($user->lang['REQ_DID_EXT']);
						}
						else {
							throw new Exception($user->lang['REQ_DID']);
						}
					}

					$status = 'billing3';
					$result = $soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml->asXML()), $status, false, false, true);
					confirmation_box($status, 'PHONE_ADDED');
				}
				catch (Exception $e) {
					confirmation_box(array('status' => '', 'error_message' => $e->getMessage()), $e->getMessage());
				}
		}
		else if (post_var('move_acct')) {
			$new_acct = request_var('new_acct', -1);

			$xml_ary = array(
				$sub_id,
				$new_acct,
			);
			$status = 'billing';
			$result = $soap->send(MOVE_SUB_TO_NEW_ACCT, $xml_ary, $status);
			redirect($page['AGENTS']);
		}
		else if (post_var('add_prov_line') && request_var('add_prov_line', 0) ) {
			// Create Dummy Feature to allow line to be created and modified.
			$update_xml = new SimpleXMLElement("<EnticeRequest></EnticeRequest>");
				$update_data = $update_xml->addChild('data');
				$update_phone = $update_data->addChild('phone');
					$update_phone->addChild('RESELLER_ID', $user->data['rsid']);
					$update_phone->addChild('CARD_ID', $sub_id);
					$update_phone->addChild('PHONE_ID', $phone_id);
					$init_feature = $update_phone->addChild('FEATURE');
						$init_feature->addAttribute('name', 'featureID');
						$init_feature->addAttribute('value', '21');
						$init_feature->addAttribute('lineId', $line_var_id);

			$status = 'autoprovisioning';
			$result = $soap->send('updatePhone', array($update_xml->asXML()), $status, false, true);
			confirmation_box($status, 'FEATURE_LINE_ADDED');
		}
		else if (post_var('add_line')) {
			$status = 'billing3';
			$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, $sub_id, $status, false, true);
			$phone = $result->xpath("//phone[PHONE_ID=$phone_id]");
			if ( $phone ) {
				try {
					$result = $phone[0];
					$linedata = false;
					foreach ( $result->phoneline as $phoneline ) {
							if ( $phoneline->EP_ALIAS == $ep_alias ) {
									$linedata=$phoneline->LINE_ID;
									break;
							}
					}
					if($linedata) {
						$line_var_id = $linedata;
						$xml_ary = array(
							$sub_id,
							$phone_id,
							$line_var_id,
						);
						$status = 'billing3';
						$xml = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);
						$row = $xml->data->children();
					}
					else {
						$xml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
						$data = $xml->addChild('data');
						$row = $data->addChild('row');
						$row->addChild('SUBSCRIBER_ID', $result->SUBSCRIBER_ID);
						$row->addChild('PHONE_ID', $result->PHONE_ID);
						$row->addChild('MAC_ADDR', $result->MAC_ADDR);
						$row->addChild('PHONE_TYPE', $result->PHONE_TYPE);
						$row->addChild('LINE_ID', $line_var_id);
						$row->addChild('EP_ALIAS', $ep_alias);
						$row->addChild('EP_PIN', $pin_id);
						
					}
					// Set flag to assign Features or not.
					$row->addChild('ASSIGN_FEATURES', $assign_features);
					
					if ( strlen($ext_id) ) {
						$number = $row->addChild('NUMBER', $ext_id);
						$number->addAttribute('type', 'EXT');
						$number->addAttribute('main', 'true');
						if ($vm_offering) {
							$number->addAttribute('vmOfferingId', $vm_offering);
							$number->addAttribute('mailbox', $ext_id);
						}
						if ( strlen($did_id) ) {
							$number = $row->addChild('NUMBER', $did_id);
							$number->addAttribute('type', 'DID');
							$number->addAttribute('main', 'false');
							if ($vm_offering) {
								$number->addAttribute('vmOfferingId', $vm_offering);
								$number->addAttribute('mailbox', $ext_id);
							}
						}
					}
					elseif ( strlen($did_id) ) {
						$number = $row->addChild('NUMBER', $did_id);
						$number->addAttribute('type', 'DID');
						$number->addAttribute('main', 'true');
						if ($vm_offering) {
							$number->addAttribute('vmOfferingId', $vm_offering);
							$number->addAttribute('mailbox', $did_id);
						}
					}
					else {
						if ( $user->data['is_pbx'] ) {
							throw new Exception($user->lang['REQ_DID_EXT']);
						}
						else {
							throw new Exception($user->lang['REQ_DID']);
						}
					}

					$xml = $xml->asXML();
					$xml = str_replace('EnticeResponse', 'EnticeRequest', $xml);
					$status = 'billing3';
					$result = $soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml), $status, false, false, true);
					confirmation_box($status, 'LINE_ADDED');
				}
				catch (Exception $e) {
					confirmation_box(array('status' => '', 'error_message' => $e->getMessage()), $e->getMessage());
				}
			}
			else {
				confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_MAC_PHONETYPE']), $user->lang['NO_MAC_PHONETYPE']);
			}
		}
		else if (post_var('add_number')) {
			$xml_ary = array(
				$sub_id,
				$phone_id,
				$line_var_id,
			);
			$status = 'billing3';
			$result = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);

			if (!$result->error) {
				$row = $result->data->children();
				$row->addChild('ASSIGN_FEATURES', $assign_features);
				try {
					if ( strlen($ext_id) ) {
						$main_ext = 'false';
						if ( !$row->xpath('//NUMBER[@type = "EXT" and @main = "true"]') ) {
							$main_ext = 'true';
						}

						$number = $row->addChild('NUMBER', $ext_id);
						$number->addAttribute('type', 'EXT');
						$number->addAttribute('main', $main_ext);
						if ($vm_offering) {
							$number->addAttribute('vmOfferingId', $vm_offering);
							$number->addAttribute('mailbox', $ext_id);
						}
						if ( strlen($did_id) ) {
							$number = $row->addChild('NUMBER', $did_id);
							$number->addAttribute('type', 'DID');
							$number->addAttribute('main', 'true');
							if ($vm_offering) {
								$number->addAttribute('vmOfferingId', $vm_offering);
								$number->addAttribute('mailbox', $ext_id);
							}
						}
					}
					elseif ( strlen($did_id) ) {
						$number = $row->addChild('NUMBER', $did_id);
						$number->addAttribute('type', 'DID');
						$number->addAttribute('main', 'true');
						if ($vm_offering) {
							$number->addAttribute('vmOfferingId', $vm_offering);
							$number->addAttribute('mailbox', $did_id);
						}
					}
					else {
						if ( $user->data['is_pbx'] ) {
							throw new Exception($user->lang['REQ_DID_EXT']);
						}
						else {
							throw new Exception($user->lang['REQ_DID']);
						}
					}

					$xml = $result->asXML();
					$xml = str_replace('EnticeResponse', 'EnticeRequest', $xml);

					$status = 'billing3';
					$result = $soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml), $status, false, false, true);
					confirmation_box($status, 'NUMBER_ADDED');
				}
				catch (Exception $e) {
					confirmation_box(array('status' => '', 'error_message' => $e->getMessage()), $e->getMessage());
				}
			}
		}
		else if (post_var('update_contact')) {
			$status_old	= request_var('status_update', 0);
			$status_new	= request_var('status', 0);

			if ($status_old != $status_new) {
				$status = 'billing3';
				$result = $soap->send(UPDATE_SUBSCRIBER_STATUS, array($sub_id, $status_new), $status);
			}

			$input_data = array(
				'email'			=> request_var('email', ''),
				'phone'			=> validate_phone(request_var('phone', '')),
				'fax'			=> validate_phone(request_var('fax', '')),
				'mobile'		=> validate_phone(request_var('mobile', '')),
				'billing_email'	=> request_var('billing_email', ''),
				'billing_phone'	=> validate_phone(request_var('billing_phone', '')),
				'billing_fax'	=> validate_phone(request_var('billing_fax', '')),
				'billing_mobile'=> validate_phone(request_var('billing_mobile', '')),
			);

			$error = validate_data($input_data, array(
// Not validating email currently
//				'email'				=> array(
//					array('string', true, 6, 60),
//					array('email', true)),
				'phone'				=> array(
					array('string', true, 7, 20)),
				'fax'				=> array(
					array('string', true, 7, 20)),
				'mobile'			=> array(
					array('string', true, 7, 20)),
				'billing_email'		=> array(
					array('string', true, 6, 60),
					array('email', true)),
				'billing_phone'		=> array(
					array('string', true, 7, 20)),
				'billing_fax'		=> array(
					array('string', true, 7, 20)),
				'billing_mobile'	=> array(
					array('string', true, 7, 20)),
			));

			$error = preg_replace('#^([A-Z_]+)$#e', "(!empty(\$user->lang['\\1'])) ? \$user->lang['\\1'] : '\\1'", $error);

			if (sizeof($error)) {
				trigger_error(implode('<br />', $error) . back_link($build_back_link));
			}

			$new_pass = utf8_normalize_nfc(request_var('password', '', true));
			$new_confirm_pass = utf8_normalize_nfc(request_var('confirm_password', '', true));
			$original_pass = utf8_normalize_nfc(request_var('original_password', '', true));

			if ( $new_pass === $new_confirm_pass ) {
				$write_password = $new_pass;
			}
			else {
				$write_password = $original_pass;
			}

			$sxml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
			$data = $sxml->addChild('data');
			$row = $data->addChild('row');
			$row->addChild('SUBSCRIBER_ID', $sub_id);
			$row->addChild('PIN', request_var('pin', 0));
			$row->addChild('BALANCE', amount_convert_from_display(request_var('balance', '')));
			$row->addChild('TTL', 0);
			$row->addChild('LIMIT', amount_convert_from_display(request_var('limit', '')));
			$row->addChild('REMARK');
			$row->addChild('USER_NAME', utf8_normalize_nfc(request_var('username', '', true)));
			$row->addChild('PASSWORD', $write_password);
			$row->addChild('ALT_ID', request_var('alt_id', ''));
			$row->addChild('LANGUAGE', request_var('lang_select', ''));
			$row->addChild('TZ_ID', request_var('tz_select', ''));
			
			if ( request_var('access_code_always', false) && $access_code_digits ) {
				$access_code_always = 'true';
			}
			else {
				$access_code_always = 'false';
			}
			$row->addChild('ACCESS_CODE_ALWAYS', $access_code_always);
			$contact = $row->addChild('contact');
				$contact->addAttribute('operation', 'update');
				$contact->addChild('CONT_ID', request_var('cont_id', 0));
				$contact->addChild('LASTNAME', utf8_normalize_nfc(request_var('last_name', '', true)));
				$contact->addChild('FIRSTNAME', utf8_normalize_nfc(request_var('first_name', '', true)));
				$contact->addChild('TITLE', utf8_normalize_nfc(request_var('title', '', true)));
				$contact->addChild('PHONE_NUM', $input_data['phone']);
				$contact->addChild('FAX_NUM', $input_data['fax']);
				$contact->addChild('MOBILE_NUM', $input_data['mobile']);
				$contact->addChild('EMAIL', $input_data['email']);
				$contact->addChild('CONTACT_TYPE_ID', CONTACT_PRIMARY);
				$contact->addChild('COMPANY', utf8_normalize_nfc(request_var('company', '', true)));
				$contact->addChild('ADDRESS1', utf8_normalize_nfc(request_var('address1', '', true)));
				$contact->addChild('ADDRESS2', utf8_normalize_nfc(request_var('address2', '', true)));
				$contact->addChild('ADDRESS3', utf8_normalize_nfc(request_var('address3', '', true)));
				$contact->addChild('CITY', utf8_normalize_nfc(request_var('city', '', true)));
				$contact->addChild('STATE', utf8_normalize_nfc(request_var('state', '', true)));
				$contact->addChild('POSTAL', request_var('postal_code', '', true));
				$contact->addChild('COUNTRY', utf8_normalize_nfc(request_var('country', '', true)));

			$billing_cont_id = request_var('billing_cont_id', 0);
			$billing_last_name = utf8_normalize_nfc(request_var('billing_last_name', '', true));
			$billing_first_name = utf8_normalize_nfc(request_var('billing_first_name', '', true));

			if ($billing_first_name && $billing_last_name) {
				$billing = $row->addChild('contact');
					$billing->addAttribute('operation', (($billing_cont_id) ? 'update' : 'add'));
					$billing->addChild('CONT_ID', $billing_cont_id);
					$billing->addChild('LASTNAME', $billing_last_name);
					$billing->addChild('FIRSTNAME', $billing_first_name);
					$billing->addChild('TITLE', utf8_normalize_nfc(request_var('billing_title', '', true)));
					$billing->addChild('PHONE_NUM', $input_data['billing_phone']);
					$billing->addChild('FAX_NUM', $input_data['billing_fax']);
					$billing->addChild('MOBILE_NUM', $input_data['billing_mobile']);
					$billing->addChild('EMAIL', $input_data['billing_email']);
					$billing->addChild('CONTACT_TYPE_ID', CONTACT_BILLING);
					$billing->addChild('COMPANY', utf8_normalize_nfc(request_var('billing_company', '', true)));
					$billing->addChild('ADDRESS1', utf8_normalize_nfc(request_var('billing_address1', '', true)));
					$billing->addChild('ADDRESS2', utf8_normalize_nfc(request_var('billing_address2', '', true)));
					$billing->addChild('ADDRESS3', utf8_normalize_nfc(request_var('billing_address3', '', true)));
					$billing->addChild('CITY', utf8_normalize_nfc(request_var('billing_city', '', true)));
					$billing->addChild('STATE', utf8_normalize_nfc(request_var('billing_state', '', true)));
					$billing->addChild('POSTAL', request_var('billing_postal_code', '', true));
					$billing->addChild('COUNTRY', utf8_normalize_nfc(request_var('billing_country', '', true)));
					$billing->addChild('MISC');
			}

			$status = 'billing3';
			$soap->send(UPDATE_SUBSCRIBER, $sxml->asXML(), $status);
			confirmation_box($status, 'SUBSCRIBER_UPDATED');
		}

		switch ($action) {
			case 'set_main_number':
				$phone_id_update = request_var('main_phone_update', 0);
				$line_id_update = request_var('main_line_update', 0);
				$xml_ary = array(
					$sub_id,
					$phone_id_update,
					$line_id_update,
				);
				$status = 'billing3';
				$phone_xml = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);

				$main_type = request_var('main_type_update', '');
				if ($main_type == '' ) {
					$main_type = 'DID';
				}
				foreach ($phone_xml->data->row->NUMBER as $num) {
					if ( $num['type'] == $main_type ) {
						if ( $num['type'] == 'EXT' ) {
							if ($num['main']) {
								unset($num['main']);
							}

							if ( $num == request_var('main_number_update', '') ) {
								$num['main'] = 'true';
							}
						}
						elseif ( $num['type'] == 'DID' ) {
							if ( $num == request_var('main_number_update', '') ) {
								$did_main = request_var('DID_'.$phone_id_update.'_'.$line_id_update.'_'.$num, false);
								if ( $did_main ) {
									$num['main'] = 'true';
								}
								else {
									unset($num['main']);
								}
							}
						}
					}
				}
				$phone_update = '<EnticeRequest>'.$phone_xml->data->asXML().'</EnticeRequest>';

				$status = 'billing3';
				$result = $soap->send(UPDATE_PHONE_LINE, array($sub_id, $phone_update), $status, false, false, true);
				confirmation_box($status, 'MAIN_NUMBER_UPDATED');

				break;

			case 'ajax_emergency':
				$filter = '';
				if ( isset($user->data['esc_layer']) ) {
					$esc_layer = $user->data['esc_layer'];
				}
				else {
					$esc_layer = array();
				}

				$found_mismatch = false;
				$layer1 = 0;
				foreach ($esc_layer as $layer_key => $layer_val) {
					if ( !$found_mismatch ) {
						$web_val = request_var('layer_'.$layer_key, '');
						if ( $web_val === '0' ) {
							$esc_layer[$layer_key] = false;
							$found_mismatch = true;
						}
						else {
							if ( $web_val != $layer_val ) {
								$esc_layer[$layer_key] = $web_val;
								$status = 'entice';
								$result = $soap->send(GET_EMERGENCY_ADDR_LOOKUP, array($filter), $status);
								$this->build_layer_select($layer1, $layer_key, $web_val, $result);
								$found_mismatch = true;
							}
							else {
								$status = 'entice';
								$result = $soap->send(GET_EMERGENCY_ADDR_LOOKUP, array($filter), $status);
								$this->build_layer_select($layer1, $layer_key, $web_val, $result);
							}
							$filter .= strtoupper($layer_key).'|'.$web_val.'|';
							$layer1++;
						}
					}
					else {
						unset($esc_layer[$layer_key]);
					}
				}

				$status = 'entice';
				$result = $soap->send(GET_EMERGENCY_ADDR_LOOKUP, array($filter), $status);
				if (sizeof($result)) {
					$array_keys = array_keys($result[0]);
					$layer2 = 0;
					foreach ($array_keys as $key) {
						if (!isset($esc_layer[$key]) || $esc_layer[$key] == '') {
							$esc_layer[$key] = false;
							$this->build_layer_select($layer2, $key, $esc_layer[$key], $result);
						}
						$layer2++;
					}
					$_SESSION['esc_layer'] = $esc_layer;

					if ($layer1 == $layer2 && $esc_layer[$key]) {
						$status = 'billing3';
						$result = $soap->send(GET_SUB_CONTACTS, array($sub_id), $status, false, true);
						( sizeof($result) ) ? $result = $result->data->row:'';

						foreach ($result as $row) {
							if ($row->CONTACT_TYPE_ID == CONTACT_EMERGENCY ) {
								$del_status = 'billing3';
								$soap->send(DELETE_SUB_CONTACTS, array($sub_id, $row->CONT_ID), $del_status, false, false, true);
							}
						}

						$esc_layer['layer_subscriberId'] = $sub_id;
						$esc_layer['layer_custId'] = $cust_id;
						$cont_bean = new contact_bean($esc_layer);
						
						$add_status = 'billing3';
						$soap->send(ADD_SUB_CONTACT, $cont_bean, $add_status);
						confirmation_box($add_status, 'UPDATE_EMERGENCY');
					}

					$status = 'billing3';
					$result = $soap->send(GET_SUB_CONTACTS, array($sub_id), $status);
					foreach ($result as $row) {
						if ($row['contact_type_id'] == CONTACT_EMERGENCY ) {
							$this->format_emergency_label($row);
							break;
						}
					}

					$template->assign_vars(array(
						'AJAX_EMERGENCY'	=> true,

						'ESC_LAYER'			=> $layer2,
					));
				}
				break;

			//remove all numbers from lines and numbers under this phone
			case 'delete_phone':
				$status = 'billing3';
				$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, $sub_id, $status, false, true);

				if (sizeof($result->data->row)) {
					$row = $result->data->row;
					$phone = $result->data->row->phone;
					$remove_subscriptions = request_var('delete_phone_sub_'.$phone_id, false);
					$referred_number	= request_var('referred_number', '');
					$delete_phone	= request_var('delete_phone', '');

					if ($delete_phone == 'add_referral' && (!$referred_number)) {
						trigger_error($user->lang['DIALED_REFERRED_NUMBERS_FILLED'] . back_link($this->u_action . '&amp;action=details'));
					}
					if ($remove_subscriptions) {
						// REMOVE Subscriptions
						$sub_feature_ids = $services->xpath('//row[PHONE_ID = "'. $phone_id . '" and END_DATE = ""]');
						foreach ($sub_feature_ids as $sub_feat_id) {
							$status = 'billing3';
							$soap->send(END_SERVICE, $sub_feat_id->SUBSCRIBED_FEATURE_ID, $status, false, false, true);
						}

						// Remove Phone
						$lang_number_deleted = '';
						foreach ($phone as $phones) {
							$del_id = request_var('phone_id', -1);
							$phone_id = ($phones->PHONE_ID > $phone_id) ? (int) $phones->PHONE_ID : (int) $phone_id;

							if ( $del_id == $phone_id ) {
								foreach ($phones->phoneline as $phonelines) {
									$xml_ary = array(
										$sub_id,
										$phone_id,
										$phonelines->LINE_ID,
									);
									$status = 'billing3';
									$result = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);

									if (isset($result->data->row->NUMBER)) {
										foreach ($result->data->row->NUMBER as $row) {
											$refer_ary[]=(string)$row+0;
										}
										unset($result->data->row->NUMBER);
										$xml = $result->asXML();
									    $xml = str_replace('EnticeResponse', 'EnticeRequest', $xml);
										$status = 'billing3';
										$soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml), $status, false, false, true);

										if ($delete_phone == 'add_referral') {
											$dis_dialed_number='';
											foreach ($refer_ary as $row) {
												$status = 'entice';
												$dialed_number = $row;
												$soap->send(ADD_REFERRAL, array($dialed_number, $referred_number), $status, false, false, true);
												if(strlen($dis_dialed_number)>0)$dis_dialed_number .=',';
												$dis_dialed_number .= $dialed_number;
											}
											$lang_number_deleted = sprintf($user->lang['PHONE_DELETED_REFERRAL_ADDED'], $referred_number, $dis_dialed_number);
										}
										else {
											$lang_number_deleted = $user->lang['PHONE_DELETED'];
										}
									}
									else if ( $result->error->errorNumber == 880 ) {
										// If no Endpoint line is found then this must be provisioning data. so remove provision data.
										$status = 'autoprovisioning';
										$soap->send(DELETE_LINE_PROVISIONING, $xml_ary, $status);
										confirmation_box($status, 'LINE_PROVISIONING_DELTED');
									}
								}
							}
						}
						confirmation_box($status, $lang_number_deleted);
					}
				}
			break;

			//remove all numbers under this line
			case 'delete_line':
				$xml_ary = array(
					$sub_id,
					$phone_id,
					$line_var_id,
				);
				$status = 'billing3';
				$result = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);

				if (isset($result->data->row->NUMBER)) {
					$count = 0;
					$trim_ary = array();
					$remove_subscriptions = request_var('delete_line_sub_'.$line_var_id.'_'.$result->data->row->EP_ALIAS, false);
					$referred_number	= request_var('referred_number', '');
					$delete_line	= request_var('delete_line', '');

					if ($delete_line == 'add_referral' && (!$referred_number)) {
						trigger_error($user->lang['DIALED_REFERRED_NUMBERS_FILLED'] . back_link($this->u_action . '&amp;action=details'));
					}
					if ($remove_subscriptions) {
						// REMOVE Subscriptions
						$sub_feature_ids = $services->xpath('//row[LINE_ID = "'. $line_var_id . '" and END_DATE = ""]');
						foreach ($sub_feature_ids as $sub_feat_id) {
							$status = 'billing3';
							$soap->send(END_SERVICE, $sub_feat_id->SUBSCRIBED_FEATURE_ID, $status, false, false, true);
						}

						// Remove Lines
						$dis_dialed_number='';

						foreach ($result->data->row->NUMBER as $row) {
							$trim_ary[] = $count;
							$count++;
						}

						foreach ($trim_ary as $row) {
							$refer_ary[] = (string)$result->data->row->NUMBER[$row]+0;
						}
						unset($result->data->row->NUMBER);
						$xml = $result->asXML();
						$xml = str_replace('EnticeResponse', 'EnticeRequest', $xml);

						$status = 'billing3';
						$soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml), $status, false, false, true);

						foreach ($refer_ary as $row) {
							$dialed_number=$row;
							if ($delete_line == 'add_referral') {
								$status = 'entice';
								$soap->send(ADD_REFERRAL, array($dialed_number, $referred_number), $status, false, false, true);
								$lang_number_deleted = sprintf($user->lang['LINE_DELETED_REFERRAL_ADDED'], $referred_number, $dialed_number);
								if(strlen($dis_dialed_number)>0)$dis_dialed_number .=',';
								$dis_dialed_number .= $dialed_number;
							}
						}
						if ($delete_line == 'add_referral') {
							$lang_number_deleted = sprintf($user->lang['LINE_DELETED_REFERRAL_ADDED'], $referred_number, $dis_dialed_number);
						}
						else {
							$lang_number_deleted = $user->lang['LINE_DELETED'];
						}
						confirmation_box($status, $lang_number_deleted);
					}
				}
				else if ( $result->error->errorNumber == 880 ) {
					// If no Endpoint line is found then this must be provisioning data. so remove provision data.
					$status = 'autoprovisioning';
					$soap->send(DELETE_LINE_PROVISIONING, $xml_ary, $status);
					confirmation_box($status, 'LINE_PROVISIONING_DELTED');
				}
			break;

			case 'delete_number':
				//remove this number
				$xml_ary = array(
					$sub_id,
					$phone_id,
					$line_var_id,
				);
				$status = 'billing3';
				$result = $soap->send(GET_PHONE_LINE, $xml_ary, $status, false, true);

				if (isset($result->data->row->NUMBER)) {
					$count = 0;
					$trim_ary = array();
					$number = request_var('number', '');
					$remove_subscriptions = request_var('delete_num_sub_'.$number, false);
					$referred_number	= request_var('referred_number', '');
					$delete_number	= request_var('delete_number', '');

					if ($delete_number == 'add_referral' && (!$referred_number)) {
						trigger_error($user->lang['DIALED_REFERRED_NUMBERS_FILLED'] . back_link($this->u_action . '&amp;action=details'));
					}

					if ($remove_subscriptions) {
						// REMOVE Subscriptions
						$sub_feature_ids = $services->xpath('//row[VIRTUAL_NUMBER = "'. $number . '" and END_DATE = "" ]');
						foreach ($sub_feature_ids as $sub_feat_id) {
							$status = 'billing3';
							$soap->send(END_SERVICE, $sub_feat_id->SUBSCRIBED_FEATURE_ID, $status, false, false, true);
						}

						// Find and remove number
						foreach ($result->data->row->NUMBER as $row) {
							if (trim($row[0]) == $number) {
								$trim_ary[] = $count;
							}
							$count++;
						}

						foreach ($trim_ary as $row) {
							$dialed_number=(string)$result->data->row->NUMBER[$row]+0;
							unset($result->data->row->NUMBER[$row]);
						}

						$xml = $result->asXML();
						$xml = str_replace('EnticeResponse', 'EnticeRequest', $xml);

						$status = 'billing3';
						$soap->send(UPDATE_PHONE_LINE, array($sub_id, $xml), $status, false, false, true);

						if ($delete_number == 'add_referral') {
							$status = 'entice';
							$soap->send(ADD_REFERRAL, array($dialed_number, $referred_number), $status, false, false, true);
							$lang_number_deleted = sprintf($user->lang['NUMBER_DELETED_REFERRAL_ADDED'], $referred_number, $dialed_number);
						}
						else {
							$lang_number_deleted = $user->lang['NUMBER_DELETED'];
						}
						confirmation_box($status, $lang_number_deleted);
					}
				}
			break;
		}

		if ($action != 'ajax_emergency') {
			$pin = '';
			$status = 'billing3';
			$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, $sub_id, $status, false, true);

			if (sizeof($result->data->row)) {
				$row = $result->data->row;
				$phone = $result->data->row->phone;
				$contact = $result->data->row->contact;
				$pin = trim($row->PIN);
				$next_phone = 1;

				$phone_count = $phoneline_count = 0;
				foreach ($phone as $phones) {
					$phone_count++;

					$phone_list = $phones->xpath("//PHONE_ID");
					for( $phone_ct = 1; $phone_ct <= sizeof($phone_list); $phone_ct++ ) {
						if ( !isset($phone_list[$phone_ct-1]) ||  $phone_ct != $phone_list[$phone_ct-1] ) {
							break;
						}
					}
					$next_phone = $phone_ct;
					$line_list = $phones->xpath('./phoneline/LINE_ID');
					$srt = new xml_sort();
					$line_list = $srt->_sort($line_list);
					
					for( $line_ct = 1; $line_ct <= sizeof($line_list); $line_ct++ ) {
						if ( !isset($line_list[$line_ct-1]) ||  $line_ct != $line_list[$line_ct-1] ) {
							break;
						}
					}
					$next_phone_line = $line_ct;

					$phoneService = $services->xpath('//row[PHONE_ID = "'. $phone_id . '" and END_DATE = ""]');
					if ( sizeof($phone_list) == 1 || (int) $phones->PHONE_ID == $phone_id ) {
						$template->assign_vars(array(
							'SHOW_LINE'			=> true,
							'SHOW_LINE_OPEN'	=> $phone_count,
							'SHOW_LINE_ACTION'	=> htmlspecialchars_decode($this->u_action . '&amp;phone_id=' . (int) trim($phones->PHONE_ID). '&amp;line_id=' . $next_phone_line),
						));
					}

					$template->assign_block_vars('phonelines', array(
						'S_FIRST_BLOCK'	=> true,
						'PHONE_ID'		=> $phones->PHONE_ID,
						'C_PHONE'		=> $phone_count,
						'ALLOWED_FEATURE_LINE'	=> (in_array(strtolower($phones->PHONE_TYPE), $this->allowed_feature_phone_type))? true : false,
				 	));

					foreach ($phones->phoneline as $phonelines) {
						$phoneline_count++;

						if (!$pin) {
							$pin = trim($phonelines->EP_PIN);
						}
						if ( ( sizeof($phones->phoneline) == 1 ) || ((int) $phones->PHONE_ID == $phone_id && (int) $phonelines->LINE_ID == request_var('main_line_update', 0)) ) {
							$template->assign_vars(array(
								'SHOW_NUM'			=> true,
								'SHOW_NUM_OPEN'		=> $phoneline_count,
								'SHOW_NUM_ACTION'	=> htmlspecialchars_decode($this->u_action . '&amp;line_id=' . $phonelines->LINE_ID . '&amp;phone_id=' . $phones->PHONE_ID),
							));
						}

						$lineService = $services->xpath('//row[LINE_ID = "'. $phonelines->LINE_ID . '" and END_DATE = ""]');

						$template->assign_block_vars('phonelines', array(
							'PHONE_ID'			=> $phones->PHONE_ID,
							'LINE_ID'			=> $phonelines->LINE_ID,
							'EP_ALIAS'			=> $phonelines->EP_ALIAS,
							'EP_PIN'			=> $phonelines->EP_PIN,
							'C_PHONE'			=> $phone_count,
							'C_LINE'			=> $phoneline_count,
							'U_ADD_NUMBER'		=> $this->u_action . '&amp;line_id=' . $phonelines->LINE_ID . '&amp;phone_id=' . $phones->PHONE_ID,
							'HAS_SUBSCRIPTION'	=> sizeof($lineService),
							'U_DELETE'			=> $this->u_action . '&amp;action=delete_line&amp;phone_id=' . $phones->PHONE_ID . '&amp;line_id=' . $phonelines->LINE_ID,
							'U_EDIT'			=> $this->u_action . '&amp;action=update_line&amp;phone_id=' . $phones->PHONE_ID . '&amp;line_id=' . $phonelines->LINE_ID,
						));

						$template->assign_block_vars('numbers', array(
							'S_FIRST_BLOCK'	=> true,
							'LINE_ID'		=> $phonelines->LINE_ID,
							'C_PHONE'		=> $phone_count,
							'C_LINE'		=> $phoneline_count,
						));

						foreach ($phonelines->NUMBER as $numbers) {
							$main_number = false;
							$numberService = $services->xpath('//row[VIRTUAL_NUMBER = "'. $numbers . '" and END_DATE = "" ]');

							if ( $numbers['main'] ) {
								$main_number = true;
							}
							$template->assign_block_vars('numbers', array(
								'TYPE'				=> $numbers['type'],
								'MAILBOX'			=> $numbers['mailbox'],
								'MAIN_NUMBER'		=> $main_number,
								'PHONE_ID'			=> $phones->PHONE_ID,
								'LINE_ID'			=> $phonelines->LINE_ID,
								'NUMBER'			=> $numbers,
								'C_PHONE'			=> $phone_count,
								'C_LINE'			=> $phoneline_count,
								'HAS_SUBSCRIPTION'	=> sizeof($numberService),
								'U_DELETE'			=> $this->u_action . '&amp;action=delete_number&amp;phone_id=' . $phones->PHONE_ID . '&amp;line_id=' . $phonelines->LINE_ID . '&amp;number=' . $numbers,
								'U_MAIN_NUMBER'		=> $this->u_action . '&amp;action=set_main_number',
							));
						}

						$template->assign_block_vars('numbers', array(
							'S_LAST_BLOCK'	=> true,
						));
					}

					$template->assign_block_vars('phonelines', array(
						'S_LAST_BLOCK'	=> true,
					));

					$template->assign_block_vars('phones', array(
						'PHONE_ID'			=> $phones->PHONE_ID,
						'MAC_ADDR'			=> $phones->MAC_ADDR,
						'PHONE_TYPE'		=> $phones->PHONE_TYPE,
						'C_PHONE'			=> $phone_count,
						'C_LINE'			=> $phoneline_count,
						'HAS_SUBSCRIPTION'	=> sizeof($phoneService),
						'U_ADD_LINE'		=> $this->u_action . '&amp;line_id=' . $next_phone_line . '&amp;phone_id=' . (int) trim($phones->PHONE_ID),
						'U_DELETE'			=> $this->u_action . '&amp;action=delete_phone&amp;phone_id=' . $phones->PHONE_ID,
					));
				}

				// Voicemail Select Box
				$status = 'billing3';
				$result = $soap->send(GET_FEATURE_OFFERINGS, array($cust_id, $acct_id), $status, false, true);
				$voicemail_offerings = $result->xpath('//row[FEATURE_TYPE_ID = "4" and FEATURE_OFFERING_LEVEL = "1"]');

				$vm_select = '<select id="voicemail_subs_' . $id . '" name="voicemail_subs">';
				$vm_select .= '<option value="0">' . $user->lang['NO_VOICEMAIL'] . '</option>';

				foreach ($voicemail_offerings as $option) {
					$vm_select .= '<option value="' . $option->FEATURE_OFFERING_ID . '">' . $option->FEATURE_NAME . '</option>';
				}
				$vm_select .= '</select>';
				$template->assign_var('VM_SELECT', $vm_select);

				// Access Code Select Box
				$ent_acc_code = array();
				$status = 'billing3';
				$result = $soap->send(GET_ENT_ACC_CODES, '<EnticeRequest><data><row><filter>CUST_ID|=|'.$cust_id.'|</filter></row></data></EnticeRequest>', $status, false, true);
				$result = $result->xpath('//row');
				foreach ( $result as $entAcc ) {
					$ent_acc_code[(string)$entAcc->ACCESS_CODE] = (string)$entAcc->DESCRIPTION;
				}

				$status = 'billing3';
				$result = $soap->send(GET_ACCESS_CODES, 'SUBSCRIBER_ID|=|'.$sub_id.'|', $status, false, true);
				$my_access_codes = array();
				$result = $result->xpath('//row');
				foreach ( $result as $subAcc ) {
					$my_access_codes[] = (string)$subAcc->ACCESS_CODE;
				}

				$access_select = '';
				if ( sizeof($ent_acc_code) ) {
					$access_select .= '<select id="access_code" name="access_code">';
					foreach ($ent_acc_code as $acc_code => $desc) {
						if ( !in_array($acc_code, $my_access_codes ) ) {
							$access_select .= '<option value="' . $acc_code . '">' . $acc_code .'-'. $desc . '</option>';
						}
					}
					$access_select .= '</select>';
					$template->assign_var('ACCESS_CODE_SELECT', $access_select);
				} else {
					$access_select .= $user->lang['NO_AVAIL_CPY_CODES'];
					$template->assign_var('ACCESS_CODE_ERROR', $access_select);
				}

				// Device type
				$status = 'autoprovisioning';
				$result = $soap->send(GET_PHONE_TYPE_AVAILABILITY, array(), $status, false, true);

				if ( $user->data['is_pbx']) {
					$result = $result->xpath('//row[AVAIL_TO_CUST_ID = "'.$cust_id.'" and AVAIL_TO_ACCT_ID=""]');
				}
				else {
					$result = $result->xpath('//row[AVAIL_TO_ACCT_ID = "'.$acct_id.'" and AVAIL_TO_CUST_ID=""]');
				}

				$device_type = '<option value="">' . $user->lang['NO_DEVICE'] . '</option>';

				if(sizeof($result)) {
					foreach ($result as $option) {
						$device_type .= '<option value="' . $option->PHONE_TYPE . '">' . $option->PHONE_TYPE . '</option>';
					}
					$no_phones = '0';
				}
				else {
					$no_phones = '1';
				}
				$template->assign_var('DEVICE_LIST_OPTIONS', $device_type);

				$status_update = $row->STATUS;
				if (strlen($status_update) == 2) {
					$status_update = substr($status_update, 1);
				}

				$status_options = '';
				foreach ($user->lang['status_options'] as $key => $lang) {
					$selected = ($key == $status_update) ? ' selected="selected"' : '';
					$status_options .= '<option value="' . $key . '"' . $selected .((in_array($key, array(2,3,4,5,7)))?' disabled="true"':'').'>' . $lang . '</option>';
				}

				/**
				 * Assign Variables to template 
				 */
				LocaleClass::getSupportedTimeZones(true, empty($row->TZ_ID)?LocaleClass::getTimezoneSettingOf($cust_id, $acct_id, ''): $row->TZ_ID);
				LocaleClass::getSupportedLanguages(true, empty($row->LANGUAGE)?LocaleClass::getLanguageSettingOf($cust_id, $acct_id, ''): $row->LANGUAGE);
				$s_hidden_fields['status_update'] = $status_update;
				$template->assign_vars(array(
					'IS_ACTIVE'		=> ($row->STATUS % 10 >= 5) ? false : true,

					'USER_NAME'		=> $row->USER_NAME,
					'PASSWORD'		=> $row->PASSWORD,
					'ALT_ID'		=> $row->ALT_ID,
					'STATUS_OPTIONS'=> $status_options,
					'LIMIT'			=> amount_convert_to_display($row->LIMIT),
					'BALANCE'		=> amount_convert_to_display($row->BALANCE),
					'ACCESS_CODE_ALWAYS'	=> $row->ACCESS_CODE_ALWAYS,

					'BALANCE_REF'	=> amount_convert_to_display($row->BALANCE_REF),
					'AVAIL_CRED'	=> amount_convert_to_display((int)$row->LIMIT - (int)$row->BALANCE_REF),
				));

				foreach ($contact as $cont) {
					$contact_array = array(
						'CONT_ID'			=> $cont->CONT_ID,
						'FIRST_NAME'		=> $cont->FIRSTNAME,
						'LAST_NAME'			=> $cont->LASTNAME,
						'TITLE'				=> $cont->TITLE,
						'PHONE_NUM'			=> $cont->PHONE_NUM,
						'FAX_NUM'			=> $cont->FAX_NUM,
						'MOBILE_NUM'		=> $cont->MOBILE_NUM,
						'EMAIL'				=> $cont->EMAIL,
						'CONTACT_TYPE_ID'	=> $cont->CONTACT_TYPE_ID,
						'COMPANY'			=> $cont->COMPANY,
						'ADDRESS1'			=> $cont->ADDRESS1,
						'ADDRESS2'			=> $cont->ADDRESS2,
						'ADDRESS3'			=> $cont->ADDRESS3,
						'CITY'				=> $cont->CITY,
						'STATE'				=> $cont->STATE,
						'POSTAL'			=> $cont->POSTAL,
						'COUNTRY'			=> $cont->COUNTRY,
						'MISC'				=> $cont->MISC,
						'MODIFIED_DATE'		=> $cont->MODIFIED_DATE,
					);

					switch ($cont->CONTACT_TYPE_ID) {
						case CONTACT_PRIMARY:
							$template->assign_vars($contact_array);
						break;

						case CONTACT_SECONDARY:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['SECONDARY_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;

						case CONTACT_BILLING:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['BILLING_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;

						case CONTACT_EMERGENCY:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['EMERGENCY_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;

						case CONTACT_OTHER:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['OTHER_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;
					}
				}
			}

			$s_hidden_fields = build_hidden_fields(array_merge($s_hidden_fields, array(
				'main_number_update'	=> '',
				'main_phone_update'		=> '',
				'main_line_update'		=> '',
				'main_type_update'		=> '',
			)));

			$xml_ary = array(
				'SELECT'	=> 'acct_new_id, cust_id, acct_id, tax, service_type',
				'FROM'		=> ACCOUNTS_TABLE,
				'WHERE'		=> 'account_type_id = ' . AGENT_AGENT . ' AND ' . 'cust_id = ' . $cust_id,
			);

			$status = 'stratus';
			$result = $soap->soap_request($xml_ary, $status);

			$service_type = -1;
			foreach ($result as $data) {
				if ( $data['acct_id'] == $acct_id ) {
					$service_type = $data['service_type'];
				}
			}

			$acct_select = '<select id="new_acct" name="new_acct">';
			foreach ($result as $data) {
				if ( $data['acct_id'] != $acct_id && $data['service_type'] == $service_type) {
					$acct_select .= '<option value="' .  $data['acct_id'] . '">' . $data['acct_new_id'] . '</option>';
				}
			}
			$acct_select .= '</select>';

			$template->assign_vars(array(
				'ACCOUNT_SELECT'	=> (strstr($acct_select, 'option'))? $acct_select : $user->lang['NO_AVAIL_ACCT'],
				'SUB_ID'			=> $sub_id,
				'S_HIDDEN_FIELDS'	=> $s_hidden_fields,
				'NEXT_PHONE_ID'		=> $next_phone,
				'PIN'				=> $pin,
				'EP_ALIAS'			=> $ep_alias,
				'U_ACTION'			=> $this->u_action,
				'U_AJAX_EMERGENCY'	=> $this->u_action.'&amp;action=ajax_emergency',
				'IS_PBX'			=> $user->data['is_pbx'],
				'PBX_ROLE'			=> $pbx_role,
			));
		}

		if ($user->data['managed_did']){
			// create did list for this customer
			$selectedDID = '';
			if (isset($user->data['is_pbx']) && $user->data['is_pbx'] ) {
				$opts = getDIDSelect($cust_id, $selectedDID, true );
			}
			else {
				$opts = getDIDSelect($cust_id, $selectedDID );
			}
			$template->assign_vars(array(
				'DID_OPTIONS' => $opts,
			));
		}

		$template->assign_vars(array(
			'SIP_TRUNK'             => $sip_trunk,
            'SHOW_EMERGENCY'        => isset($config['show_emergency'])?$config['show_emergency']:true,
            'EXPOSE_EP_ALIAS'       => isset($config['expose_epalias'])?$config['expose_epalias']:false,
            'MANAGED_DID'           => $user->data['managed_did'],
            'ADD_PHONE'             => isset($config['add_phone']["$pbx_role"])?$config['add_phone']["$pbx_role"]:true,
            'ADD_LINE'              => isset($config['add_line']["$pbx_role"])?$config['add_line']["$pbx_role"]:true,
			'ADD_NUMBER'            => isset($config['add_number']["$pbx_role"])?$config['add_number']["$pbx_role"]:true,
			'SHOW_PHONE_LINE_TREE'	=> isset($config['show_phone_line_tree']["$pbx_role"])?$config['show_phone_line_tree']["$pbx_role"]:true,
			'NO_PHONES'				=> isset($no_phones)? $no_phones: false,
            'U_AJAX_EMERGENCY'      => $this->u_action.'&amp;action=ajax_emergency',
            'SERVICE_TYPE'          => $act_service_type,
            'IS_PBX'                => isset($user->data['is_pbx'])? $user->data['is_pbx']: false,
		));
	}

	function format_emergency_label($contact) {
		global $template, $user;
		$allowed_list = array('address1','address2','address3','city','state','postal','country','county','district');

		$eme_details = '';
		foreach ($contact as $key => $val) {
			if (in_array($key, $allowed_list) && $val != '') {
				$eme_details .= '<dt>'.$user->lang[strtoupper($key)] . '</dt><dd>' . $val . '</dd>';
			}
		}
		(strlen($eme_details) == 0)?$eme_details = $user->lang['NO_LOC_SELECTED']: '';

		$eme_label = '
		<h3 style="padding-left:10px;">'.$user->lang['CURRENT_EME_LOC'].'</h3>
		<fieldset style="margin-left:5px;"><dl>'.$eme_details.'</dl></fieldset>';

		$template->assign_var('EMERGENCY_LABEL', $eme_label);
		return;
	}

	function build_layer_select($layer, $key, $value, $options) {
		global $user, $template;

		$layer_select = '<select id="layer_'.$key.'" name="layer_'.$key.'" onchange="send(\'submit\', \''.$this->u_action.'&amp;action=ajax_emergency\' , this.form, \'dyn_emergency\', true);">';
		$layer_select .= '<option value="0">'.$user->lang['SELECT_ONE'].'</option>';
		foreach ($options as $opt) {
			$layer_select .= '<option value="'.$opt[$key].'" '.(($opt[$key]==$value)?'selected':'').'>'.$opt[$key].'</option>';
		}
		$layer_select .= '</select>';

		$template->assign_vars(array(
			'LAYER_'.$layer.'_LANG'		=> $user->lang[strtoupper($key)],
			'LAYER_'.$layer.'_SELECT'	=> $layer_select,
		));

		return;
	}
}

//class contact_bean {
//
//    public $acctId = null; // NUMBER(10,0)
//    public $address1 = null; // VARCHAR2(128) NULLABLE
//    public $address2 = null; // VARCHAR2(128) NULLABLE
//    public $address3 = null; // VARCHAR2(128) NULLABLE
//    public $subscriberId = null; // NUMBER(10,0) NULLABLE
//    public $city = null; // VARCHAR2(128) NULLABLE
//    public $company = null; // VARCHAR2(128) NULLABLE
//    public $contactTypeId = 5; // NUMBER(10,0) NOT NULL
//    public $contId = 0; // NUMBER(10,0) NOT NULL
//    public $country = null; // VARCHAR2(128) NULLABLE
//    public $custId = null; // NUMBER(10,0) NULLABLE
//    public $email = null; // VARCHAR2(255) NULLABLE
//    public $faxNum = null; // VARCHAR2(24) NULLABLE
//    public $firstName = null; // VARCHAR2(128) NULLABLE
//    public $lastName = null; // VARCHAR2(128) NULLABLE
//    public $misc = null; // VARCHAR2(256) NULLABLE
//    public $mobileNum = null; // VARCHAR2(24) NULLABLE
//    public $phoneNum = null; // VARCHAR2(24) NULLABLE
//    public $postal = null; // VARCHAR2(20) NULLABLE
//    public $state = null; // VARCHAR2(128) NULLABLE
//    public $title = null; // VARCHAR2(64) NULLABLE
//
//	function contact_bean($data = array()) {
//		if ( sizeof($data) ) {
//			foreach ($data as $item => $val) {
//				$local_item = str_replace('layer_', '', $item);
//				$this->$local_item = $val;
//			}
//			$this->contactTypeId = CONTACT_EMERGENCY;
//		}
//	}
//}
