<?php
/**
*
* common [English]
*
* @author Lorence Smith
* @package reseller modules
* @version $Id: maintain.php,v 1.119 2011/05/19 10:05:04 henryhou Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

/**
 * @ignore
 */
if (!defined('IN_ENTICE')) {
	exit();
}

/**
 * Class Includes
 */
require_once ($GLOBALS['common_path'] . 'classes/LocaleClass.php');

/**
* reseller_agent_maintenance
* Reseller Agent Maintenance
* @package reseller
*/
class maintain
{
	public $u_action;
	public $module_class;

	function main($id, $mode)
	{
		global $soap, $user, $template, $config, $read_only, $phpEx, $common_path;

		$action			= request_var('action', '');
		$acct_id		= request_var('acct_id', 0);
		$cust_id		= request_var('cust_id', 0);
		$fee_id			= request_var('fee_id', 0);
		$sub_id			= request_var('sub_id', '');
		$service_type	= request_var('service_type', '');
		$phone_type = '';
		
		if (post_var('validate_data'))
		{
			require($common_path . 'includes/functions_user.' . $phpEx);
			$validate_ary = array(
				'login_name'	=> request_var('login_name',  ''),
				'password'		=> request_var('password',  ''),
				'first_name'	=> request_var('first_name',  ''),
				'last_name'		=> request_var('last_name',  ''),
				'did'			=> request_var('did',  ''),
				'ep_alias'		=> request_var('ep_alias',  ''),
				'ep_pin'		=> request_var('ep_pin',  ''),
				'phone_type'	=> request_var('phone_type', ''),
				'email'			=> request_var('email', ''),
			);
			$error = validate_data($validate_ary, array(
					'login_name'			=> array(
						array('string', false, 1, 64 )),
					'password'			=> array(
						array('string', false, 1, 64 )),
					'first_name'			=> array(
						array('string', false, 1, 128 )),
					'last_name'			=> array(
						array('string', false, 1, 128)),
					'did'			=> array(
						array('string', false, 1, 20)),
					'phone_type'			=> array(
						array('string', false, 1, 256)),
					'ep_alias'			=> array(
						array('string', true, 0, 32)),
					'ep_pin'			=> array(
						array('string', true, 0, 10)),
					'email'			=> array(
						array('email', true ))

			));
			return_error_data($error);
		}
		
		// prepaid = 1 ; postpaid = 2
		$screen			= request_var('screen', '');

		$page = array(
			'AGENTS'	=> $this->u_action,
		);
		breadcrumbs($page);

		$sub_id_param = ($sub_id) ? '&amp;sub_id=' . $sub_id : '';
		$this->u_action .= ($acct_id && $cust_id) ? $sub_id_param . '&amp;acct_id=' . $acct_id . '&amp;cust_id=' . $cust_id . '&amp;fee_id=' . $fee_id . '&amp;service_type=' . $service_type: '';

		//add update and delete actions happen first
		switch ($action)
		{
			case 'add':
				$xml = $this->add_subscriber();
				$status = 'billing3';
				$soap->send(ADD_SUBSCRIBER, array($xml->asXML()), $status, false, false, true);
				confirmation_box($status, 'SUCCESS', $xml->xpath('//USER_NAME'));
				if ($status['error_message']) {
					if (request_var('assign_features', '')) {
						$assign_features = true;
					}
					else {
						$assign_features = false;
					}
					$template->assign_vars(array(
						'LOGIN_NAME'	=> request_var('login_name',  ''),
						'PASSWORD'		=> request_var('password',  ''),
						'EMAIL'			=> request_var('email',  ''),
						'FIRST_NAME'	=> request_var('first_name',  ''),
						'LAST_NAME'		=> request_var('last_name',  ''),
						'EXT'			=> request_var('ext',  ''),
						'DID'			=> request_var('did',  ''),
						'EP_ALIAS'		=> request_var('ep_alias', ''),
						'ALT_ID'		=> request_var('alt_id',  ''),
						'EP_PIN'		=> request_var('ep_pin', ''),
						'MAC_ADDRESS'	=> request_var('mac_address', ''),
						'ASSIGN_FEATURES'		=> $assign_features,
					));
	
					$phone_type = request_var('phone_type','');
					$vm_type = request_var('voicemail_subs','');
					$auto_open = true;
				}
				$action = 'details';
			break;

			case 'delete':
				$submit				= (isset($_REQUEST['submit'])) ? true : false;
				$referred_number	= request_var('referred_number', '');
				$delete_sub			= request_var('delete_sub', '');

				if (!$submit)
				{
					break;
				}

				if ($delete_sub == 'add_referral' && (!$referred_number))
				{
					trigger_error($user->lang['REFERRED_NUMBERS_FILLED'] . back_link($this->u_action . '&amp;action=details'));
				}

				if ($delete_sub == 'add_referral')
				{
					$status = 'billing3';
					$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, array($sub_id), $status, false, true);
					if ( !$result->error )
					{
						$dialed_numbers = $result->xpath('//phone/phoneline/NUMBER');
					}
					$status = 'billing3';
					$soap->send(TERMINATE_SUBSCRIBER, array($sub_id), $status, false, false, true);
					confirmation_box($status, $user->lang['SUBSCRIBER_DELETED']);

					// Get Subscriber Numbers and refer each of them.
					foreach ($dialed_numbers as $num) {
						$status_ref = 'entice';
						$soap->send(ADD_REFERRAL, array((string)$num, (string)$referred_number), $status_ref, false, false, true);
						$lang_subscriber_deleted = sprintf($user->lang['REFERRAL_ADDED'], $referred_number, (string)$num);	;
						confirmation_box($status_ref, $lang_subscriber_deleted);
					}
					$status = 'entice';
				}
				else
				{
					$status = 'billing3';
					$soap->send(DELETE_SUBSCRIBER, array(request_var('sub_id', '')), $status, false, false, true);
					confirmation_box($status, $user->lang['DELETE_SUBSCRIBER']);
				}
				$action = 'details';
			break;
		}

		//now the viewing actions
		switch ($action)
		{
			//view line details popup
			case 'line_details':
				$xml_ary = array(
					request_var('sip', ''),
				);

				$status = 'entice';
				$xml = $soap->send(GET_SIP_ENDPOINT_STATUS, $xml_ary, $status, false, true, true);

				if (!$xml->error)
				{
					$xml = $xml->data->row->data;

					if (sizeof($xml))
					{
						foreach ($xml as $row)
						{
							$template->assign_var(strtoupper(str_replace(' ', '_', $row->attributes())), $row);
						}
					}
				}
				$template->assign_vars(array(
					'DID'				=> preg_replace( '/[\D]/', '', request_var('did', '')),
					'S_LINE_DETAILS'	=> true,
				));
			break;

			//add/edit network features popup
			case 'network_features':
				$main_number = preg_replace( '/[\D]/', '', request_var('did', ''));
				if (!$main_number)
				{
				    $main_number = request_var('sip', '');
				}

				if (post_var('submit'))
				{
					$status = 'entice';
					$result = $soap->send(GET_SUBSCRIBER_FEATURE, array($main_number), $status, false, false, true);
					(sizeof($result))?$result = $result[0]: $result = array();
					$features = new subfeature($result);

					$status = 'entice';
					$sub_result = $soap->send(GET_SUBSCRIBER_FEATURE_PARMS, array($main_number, null), $status, false, true, true);
					($sub_result->error->errorNumber == '')?$sub_result = $sub_result->data->row : $sub_result = array();


					//Don't delete anymore the add now does an internal update
//					$status = 'entice';
//					$soap->send(DELETE_SUBSCRIBER_FEATURE, $main_number, $status, false, false, true);

					/**
					 * Delete List - Only delete ones that we save and update with deprecated call ADD_SUBSCRIBER_FEATURE_PARMS
					 */
					$deleteList = array(0, 1, 2, 3, 4, 5);
					foreach ( $deleteList as $deleteIndex )
					{
							$status = 'entice';
							$soap->send(DELETE_SUBSCRIBER_FEATURE_PARM, array($main_number, $deleteIndex), $status, false, false, true);
					}

					//setup the feature object
					$features->mainNumber = $main_number;
					$features->feature0 = request_var('follow_me_option', 0);
					$features->status0 = request_var('follow_me', 0);
					$features->status1 = request_var('forward_always', 0);
					$features->status2 = request_var('forward_busy', 0);
					$features->status3 = request_var('forward_noanswer', 0);
					$features->status4 = request_var('donot_disturb', 0);
					$features->status5 = request_var('color_ring', 0);
//					$features->status6 = request_var('anonymous_call_barring', 0);
					$features->status7 = request_var('caller_id_display', 0);
					$features->status8 = request_var('call_fwd', 0);
					$features->status9 = request_var('caller_id_withhold', 0);

					$status = 'entice';
					$soap->send(ADD_SUBSCRIBER_FEATURE, $features, $status, false, false, true);
					confirmation_box($status, 'ADD_SUBSCRIBER_FEATURE');

					// set the anonymous call barring
					$acb_stat = request_var('anonymous_call_barring', 0);
					if ($acb_stat >= 1)
					{
						//SoapReturn changeFeatureAnonymousCallBarring(
						//		int resellerId, String resellerKey,
						//		String mainNumber, int status, String sendTo, String userId)
						$xml_ary = array(
							$features->mainNumber,
							$acb_stat,
							request_var('anonymous_call_options', 0),
						);

						$status = 'entice';
						$result = $soap->send(CHANGE_FEATURE_ANONYMOUS_CALL_BARRING, $xml_ary, $status, false, false, true);
						if ($status['error'])
						{
							confirmation_box($status, 'ADD_SUBSCRIBER_FEATURE');
						}
					}

					// set the caller_id_withhold
					//SoapReturn changeFeatureCallerIdWithhold(int resellerId, String resellerKey,
					//			String mainNumber, int status, String restricted,
					//			String userId, int custId);
					$call_Id = ($features->status9 == 1) ? 'R' : 'A' ;
					$acb_stat = request_var('caller_id_withhold', 0);
					$xml_ary3 = array(
						$features->mainNumber,
						$acb_stat,
						$call_Id,
						$user->data['user_id'],
						$cust_id,
					);
					$status3 = 'entice';
					$soap->send(UPDATE_FEATURE_CALLER_ID_WITHHOLD, $xml_ary3, $status3);
					if ($status3['error'])
					{
						confirmation_box($status3, 'ADD_SUBSCRIBER_FEATURE');
					}

					//now add parms
					$array = array();
					$has_num = false;
					if ($features->status0)
					{
						$numbers = request_var('follow_number', array(''));
						$numbers = array_merge(array_filter($numbers), array());
						$feature = $features->feature0;
						$number = $features->mainNumber;

						foreach ($numbers as $key => $var)
						{
							if ($var)
							{
								$array[] = new subfeatureparm($number, $feature, $key, $var);
								$has_num = true;
							}
						}
						if ( !$has_num )
						{
							// No Numbers set status to disabled
							$features->status0 = 2;
						}
					}
					else
					{
						
						if(sizeof($sub_result))
						{
							foreach ( $sub_result->xpath("//row[FEATURE = \"0\"]") as $thisParm )
							{
								$array[] = new subfeatureparm($thisParm->MAIN_NUMBER, $thisParm->FEATURE, $thisParm->F_PARM, $thisParm->F_NUMBER, $thisParm->ACTION);
							}
						}
					}


					// Setting parms for feature1 - Feature Index 1, Feature #3 - Call Forward Always
					$number1 = request_var('number1', '');
					$action1 = request_var('fa_option', 0);
					if ($features->status1)
					{
						if ($number1 && $action1)
						{
							// If they select number and specify a number set them.
							$array[] = new subfeatureparm($features->mainNumber, $features->feature1, 0, $number1, $action1);
						}
						else
						{
							// Else force forward to voicemail
							$array[] = new subfeatureparm($features->mainNumber, $features->feature1, 0, $number1, 0);
						}
					}
					else
					{
						if(sizeof($sub_result))
						{
							foreach ( $sub_result->xpath("//row[FEATURE = \"1\"]") as $thisParm )
							{
								$array[] = new subfeatureparm($thisParm->MAIN_NUMBER, $thisParm->FEATURE, $thisParm->F_PARM, $thisParm->F_NUMBER, $thisParm->ACTION);
							}
						}
					}

					// Setting parms for feature2 - Feature Index 2, Feature #4 - Call Forward on Busy
					$number2 = request_var('number2', '');
					$action2 = request_var('fb_option', 0);
					if ($features->status2)
					{
						if ($number2 && $action2)
						{
							// If they select number and specify a number set them.
							$array[] = new subfeatureparm($features->mainNumber, $features->feature2, 0, $number2, $action2);
						}
						else
						{
							// Else force forward to voicemail
							$array[] = new subfeatureparm($features->mainNumber, $features->feature2, 0, $number2, 0);
						}
					}
					else
					{
						if(sizeof($sub_result))
						{
							foreach ( $sub_result->xpath("//row[FEATURE = \"2\"]") as $thisParm )
							{
								$array[] = new subfeatureparm($thisParm->MAIN_NUMBER, $thisParm->FEATURE, $thisParm->F_PARM, $thisParm->F_NUMBER, $thisParm->ACTION);
							}
						}
					}

					//Setting parms for feature 3 - Call Forward when no answer
					$number3 = request_var('number3', '');
					$action3 = request_var('fna_option', 0);
					if ($features->feature3)
					{
						if ($number3 && $action3)
						{
							// If they select number and specify a number set them.
							$array[] = new subfeatureparm($features->mainNumber, $features->feature3, 0, $number3, $action3);
						}
						else
						{
							// Else force forward to voicemail
							$array[] = new subfeatureparm($features->mainNumber, $features->feature3, 0, $number3, 0);
						}
					}
					else
					{
						if(sizeof($sub_result))
						{
							foreach ( $sub_result->xpath("//row[FEATURE = \"3\"]") as $thisParm )
							{
								$array[] = new subfeatureparm($thisParm->MAIN_NUMBER, $thisParm->FEATURE, $thisParm->F_PARM, $thisParm->F_NUMBER, $thisParm->ACTION);
							}
						}
					}

					$status = 'entice';
					$soap->send(ADD_SUBSCRIBER_FEATURE_PARMS, $array, $status, false, false, true, false);
					if ($status['error'])
					{
						confirmation_box($status, 'ADD_SUBSCRIBER_FEATURE');
					}
					$template->assign_var('S_NETWORK_FEATURES', true);
				}
				
				

				//display network features
				// get feature names
				//$acct_id = $user->data['acct_id'];
				$xml = new SimpleXMLElement('<row></row>');
				$xml->addChild('CUST_ID', $cust_id);
				$xml->addChild('ACCT_ID', $acct_id);
				$xml->addChild('filter', "CUST_ID|=|".$cust_id."|ACCT_ID|=|".$acct_id);
				$status = 'billing3';
				$result = $soap->send(GET_FEATURE_OFFERINGS_XML, $xml->asXML(), $status, false, true);
				$result = $result->xpath('//row');
				$name_arr = array();
				foreach ($result as $row) {
					$name_arr[(string)$row->FEATURE_TYPE_ID] = $row->FEATURE_NAME;
				}
				$template->assign_vars(array(
					'DND_NAME'			=> (!empty($name_arr[1]))?$name_arr[1]:$user->lang['DONOT_DISTURB'],
					'FOLLOW_NAME'		=> (!empty($name_arr[2]))?$name_arr[2]:$user->lang['FOLLOW_ME'],
					'CF_NAME'			=> (!empty($name_arr[3]))?$name_arr[3]:$user->lang['CALL_FORWARD'],
					'ACB_NAME'			=> (!empty($name_arr[5]))?$name_arr[5]:$user->lang['ANONYMOUS_CALL_BARRING'],
					'CID_WITHHOLD_NAME'	=> (!empty($name_arr[6]))?$name_arr[6]:$user->lang['CALLER_ID_WITHHOLD'],
					'CID_NAME'			=> (!empty($name_arr[7]))?$name_arr[7]:$user->lang['CALLER_ID_DISPLAY'],
					'ACF_NAME'			=> (!empty($name_arr[13]))?$name_arr[13]:$user->lang['ADVANCED_CALL_FORWARDING'],
					//'CF_NAME'			=> $name_arr[14],
				));
				
				
				// get fetures
				$status = 'entice';
				$result = $soap->send(GET_SUBSCRIBER_FEATURE_CODES, array(), $status);

				foreach ($result as $rowa)
				{
					$xml_ary = array(
						$main_number,
						$rowa['feature'],
					);
					$status = 'entice';
					$result2 = $soap->send(GET_SUBSCRIBER_FEATURE_PARMS, $xml_ary, $status, false, false, true);
					foreach ($result2 as $row)
					{
						switch ($rowa['feature'])
						{
							case 1:
							case 2:
								$template->assign_var('FOLLOW_NUMBER' . $row['f_parm'], $row['f_number']);
								$template->assign_var((($row['feature'] == 2) ? 'FM_SEQUENTIAL' : 'FM_MULTI_RING'), 'selected="selected"');
							break;
							case 3:
								$template->assign_var('FORWARD_ALWAYSNUM', $row['f_number']);
								$template->assign_var((($row['action'] == 1) ? 'FA_NUM' : 'FA_VM'), 'selected="selected"');
							break;
							case 4:
								$template->assign_var('FORWARD_BUSYNUM', $row['f_number']);
								$template->assign_var((($row['action'] == 1) ? 'FB_NUM' : 'FB_VM'), 'selected="selected"');
							break;
							case 5:
								$template->assign_var('FORWARD_NOANSWERNUM', $row['f_number']);
								$template->assign_var((($row['action'] == 1) ? 'FNA_NUM' : 'FNA_VM'), 'selected="selected"');
							break;
							// Anonymous Call Barring ACB
							case 7:
								$template->assign_var((($row['action'] == 1) ? 'ACB_ANNOUNCEMENT' : 'ACB_VOICEMAIL'), 'selected="selected"');
							break;
						}
					}
				}

				$xml_ary = array(
					$main_number,
				);
				$status = 'entice';
				$result = $soap->send(GET_SUBSCRIBER_FEATURE, $xml_ary, $status, false, false, true);

				if (sizeof($result))
				{
					foreach ($result as $row)
					{
						$template->assign_vars(array(
							'MAIN_NUMBER'							=> $main_number,

							'FOLLOW_ME_STATUS'						=> gen_network_feature_status('follow_me', $row['status_0'], 'onchange="show_hide_option_box(\'follow_me\', \'follow_me_options\');show_hide_option_box(\'follow_me\', \'follow_me_title\');"'),
							'FM_STATUS'								=> $row['status_0'],

							'FORWARD_ALWAYS_STATUS'					=> gen_network_feature_status('forward_always', $row['status_1'], 'onchange="show_hide_option_box(\'forward_always\', \'fa_options\', \'fa_num_box\');"'),
							'FA_STATUS'								=> $row['status_1'],
							'FORWARD_BUSY_STATUS'					=> gen_network_feature_status('forward_busy', $row['status_2'], 'onchange="show_hide_option_box(\'forward_busy\', \'fb_options\', \'fb_num_box\');"'),
							'FB_STATUS'								=> $row['status_2'],
							'FORWARD_NOANSWER_STATUS'				=> gen_network_feature_status('forward_noanswer', $row['status_3'], 'onchange="show_hide_option_box(\'forward_noanswer\', \'fna_options\', \'fna_num_box\');"'),
							'FNA_STATUS'							=> $row['status_3'],
							'DONOT_DISTURB_STATUS'					=> gen_network_feature_status('donot_disturb', $row['status_4']),
//							'changeFeatureColorRing' => '5', /// :TODO this feature
							'ANONYMOUS_CALL_BARRING_STATUS'			=> gen_network_feature_status('anonymous_call_barring', $row['status_6'], 'onchange="show_hide_option_box(\'anonymous_call_barring\', \'anonymous_call_options\');"'),
							'ACB_STATUS'							=> $row['status_6'],
							'CALLER_ID_DISPLAY_STATUS'				=> gen_network_feature_status('caller_id_display', $row['status_7']),
							'ADVANCED_CALL_FORWARD_STATUS'			=> gen_network_feature_status('call_fwd', $row['status_8']),
							'ACF_STATUS'							=> $row['status_8'],
							'CALLER_ID_WITHHOLD_STATUS'				=> gen_network_feature_status('caller_id_withhold', $row['status_9']),
						));
					}
				}
				else
				{
					$template->assign_vars(array(
						'MAIN_NUMBER'							=> $main_number,

						'FOLLOW_ME_STATUS'						=> gen_network_feature_status('follow_me', 0, 'onchange="show_hide_option_box(\'follow_me\', \'follow_me_options\');show_hide_option_box(\'follow_me\', \'follow_me_title\');"'),
						'FM_STATUS'								=> 0,
						'FORWARD_ALWAYS_STATUS'					=> gen_network_feature_status('forward_always', 0, 'onchange="show_hide_option_box(\'forward_always\', \'fa_options\', \'fa_num_box\');"'),
						'FA_STATUS'								=> 0,
						'FORWARD_BUSY_STATUS'					=> gen_network_feature_status('forward_busy', 0, 'onchange="show_hide_option_box(\'forward_busy\', \'fb_options\', \'fb_num_box\');"'),
						'FB_STATUS'								=> 0,
						'FORWARD_NOANSWER_STATUS'				=> gen_network_feature_status('forward_noanswer', 0, 'onchange="show_hide_option_box(\'forward_noanswer\', \'fna_options\', \'fna_num_box\');"'),
						'FNA_STATUS'							=> 0,
						'DONOT_DISTURB_STATUS'					=> gen_network_feature_status('donot_disturb'),
//						'changeFeatureColorRing' => '5', /// :TODO this feature
						'ANONYMOUS_CALL_BARRING_STATUS'			=> gen_network_feature_status('anonymous_call_barring', 0, 'onchange="show_hide_option_box(\'anonymous_call_barring\', \'anonymous_call_options\');"'),
						'ACB_STATUS'							=> 0,
						'CALLER_ID_DISPLAY_STATUS'				=> gen_network_feature_status('caller_id_display'),
						'ADVANCED_CALL_FORWARD_STATUS'			=> gen_network_feature_status('call_fwd'),
						'CALLER_ID_WITHHOLD_STATUS'				=> gen_network_feature_status('caller_id_withhold'),
					));
				}

				$template->assign_vars(array(
					'S_NETWORK_FEATURES'			=> true,
					'U_NETWORK_FEATURES'			=> $this->u_action . '&amp;action=' . $action . '&amp;sip=' . $main_number,
					'U_ADVANCED_CALL_FORWARDING'	=> str_replace('mode=' . $mode, 'mode=call_forwarding', $this->u_action) . '&amp;did=' . $main_number . '&amp;sip=' . request_var('sip', ''). '&amp;sub_id=' . request_var('sub_id', ''),
				));
			break;

			case 'details':

				$limit = request_var('limit', 25);
				$start = request_var('start', 0);
				$search = post_var('search');
				$filter = search_results('subscriber', $start);
				search_options('subscriber', array(
					'SUBSCRIBERS'	=> 'disabled',

					'firstname'		=> 'FIRST_NAME',
					'lastname'		=> 'LAST_NAME',
					'alt_id'		=> 'ALT_ID',
					'phone_id'		=> 'PHONE',
					'line_id'		=> 'LINE',
					'value'			=> 'DID',
//					'subscriber_id'	=> 'SUBSCRIBER_ID',
//					'ep_alias'		=> 'EP_ALIAS',
//					'phone_type'	=> 'PHONE_TYPE',
//					'value_type'	=> 'VALUE_TYPE',
				));

				if ($limit <= 0) {
					$limit = 25;
				}
				$page = ceil(($start + 1) / $limit);

				LocaleClass::getSupportedTimeZones(true, LocaleClass::getTimezoneSettingOf($cust_id, $acct_id, ''));
				LocaleClass::getSupportedLanguages(true, LocaleClass::getLanguageSettingOf($cust_id, $acct_id, ''));
				
				$array = array (
					$cust_id,
					$acct_id,
					$page,
					$limit,
					'', //sort field
					$filter, //filter
				);
				$status = 'billing3';
				$result = $soap->send(GET_SUBSCRIBER_ACCT_ID, $array, $status);

				foreach ($result as $row) {
					$service_status = 'billing3';
					$service_result = $soap->send(GET_ACTIVE_SERVICES, $row['subscriber_id'], $service_status, false, true);
					$voicemail_result = $service_result->xpath('//row[FEATURE_TYPE_ID = "4" and VIRTUAL_NUMBER = "'.$row['value'].'"]');

					$template->assign_block_vars('details', array(
						'ALT_ID'				=> $row['alt_id'],
						'EP_ALIAS'				=> $row['ep_alias'],
						'NAME'					=> $row['fullname'],
						'PHONE'					=> $row['phone_id'],
						'TYPE'					=> $row['phone_type'],
						'LINE'					=> $row['line_id'],
						'LINE_NUMBER'			=> $row['line_id'],
						'DID'					=> $row['value'],

						'IS_ACTIVE'				=> ($row['status'] % 10 >= 5) ? false : true,
						'HAS_VOICEMAIL'			=> sizeof($voicemail_result)? true : false,

						'U_LINE_DETAILS'		=> $this->u_action . '&amp;action=line_details&amp;did=' . $row['value'] . '&amp;sip=' . $row['ep_alias'],
						'U_EDIT_SUBSCRIBER'		=> str_replace('mode=' . $mode, 'mode=edit_subscriber', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
//						'U_NETWORK_FEATURES'	=> $this->u_action . '&amp;action=network_features&amp;sip=' . $row['ep_alias'],
						'U_VOICEMAIL_ADMIN'		=> str_replace('mode=' . $mode,'mode=voicemail_admin', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
						'U_NETWORK_FEATURES'	=> $this->u_action . '&amp;action=network_features&amp;sip=' . $row['ep_alias'] . '&amp;did=' . $row['value']. '&amp;sub_id=' . $row['subscriber_id'],
						'U_LINE_MAINTENANCE'	=> str_replace('mode=' . $mode, 'mode=line_maintenance', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
						'U_ADVANCED_CALL_FORWARDING'	=> str_replace('mode=' . $mode, 'mode=call_forwarding', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
						'U_DELETE_SUBSCRIBER'	=> $this->u_action . '&amp;action=delete&amp;sub_id=' . $row['subscriber_id'],
						'U_SUBSCRIBED_FEATURES'	=> str_replace('mode=' . $mode, 'mode=features', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
					));
				}

				$template->assign_vars(array(
					'U_READ_ONLY'		=> $read_only,
					'CUST_ID'			=> $cust_id,
					'ACCT_ID'			=> $acct_id,
				    'FEE_ID'			=> $fee_id,
					'SERVICE_TYPE'		=> $service_type,
					'SCREEN'			=> ($search)?'' : $screen,

				    // pagination
					'PAGINATION'	=> generate_pagination(str_replace('&amp;start=' . $start, '', $this->u_action . '&amp;action=details&amp;limit=' . $limit), $status['total_rows'], $limit, $start, true),
					'PAGE_NUMBER'	=> on_page($status['total_rows'], $limit, $start),
				));
			break;

			default:
				$psort_dir	= request_var('sd', 'a');
				$psort_key	= request_var('sk', 'acct_new_id');

				// sort by elements
				$sort_by_text = array(
					'p'		=> $user->lang['PRODUCTS'],
					'r'		=> $user->lang['AGENTS'],
				);

				// the keys must match the above sort by. -- the below values must correspond to the soap call/database
				$sort_by_sql = array(
					'p'		=> 'acct_new_id',
					'r'		=> 'name',
				);

				$s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($sort_by_text, $psort_key, $psort_dir, $s_sort_key, $s_sort_dir, $u_sort_param);
				// this will ensure that the sort directions are retained in pagination.
				$this->u_action .= '&amp;' . $u_sort_param;
				$filter = search_results('suscriber_maintenance', $start, false);
				search_options('suscriber_maintenance', array(
					'MAINTAIN_SUBSCRIBERS'		=> 'disabled',
		
					'c.acct_new_id'		=> 'PRODUCTS',
					'b.name'			=> 'AGENTS',
				));
				
				$xml_ary = array ('SELECT' => 'b.name, b.cust_id, c.acct_new_id, c.feeplan_id, c.acct_id, c.service_type',
		                  'FROM' => array (CUSTOMER_TABLE => 'a' ),
		                  'LEFT_JOIN' =>array (
										array ('FROM' => array (CUSTOMER_TABLE => 'b' ),
		                                          'ON' => 'a.cust_new_id = b.signup_by'),
						  'INNER_JOIN' =>array ('FROM' => array (ACCOUNT_TABLE => 'c' ),
		                                        'ON' => 'c.cust_id = b.cust_id'  ) ),
   						'WHERE'		=> 'b.business_type_id = 1 AND a.cust_id = ' . $user->data['rsid'] . '  AND c.account_type_id = ' . AGENT_AGENT. (($filter) ? ' AND ' . $filter : '') ,
						'ORDER_BY'	=> $sort_by_sql[$psort_key] . ' ' . $psort_dir,);
				
				$status = 'stratus';
				$agent_results = $soap->soap_request($xml_ary, $status);
				$cust_ary = array();
				if (sizeof($agent_results))
				{
					foreach ($agent_results as $row)
					{
						$cust_ary[$row['cust_id']] = $row['cust_id'];
					}
				}
					foreach ($agent_results as $row)
					{
						$template->assign_block_vars('products', array(
							'PRODUCT_NAME'		=> $row['acct_new_id'],
							'AGENT_NAME'		=> $row['name'],
							'PRODUCT_ID'		=> $row['acct_id'],
						
							'SERVICE_TYPE'		=> $row['service_type'],
						
							'U_DETAILS'			=> $this->u_action . '&amp;action=details&amp;acct_id=' . $row['acct_id'] . '&amp;cust_id=' . $row['cust_id'] . '&amp;fee_id=' . $row['feeplan_id']. '&amp;service_type=' . $row['service_type'],
						));
					}

					$template->assign_vars(array(
						'S_PSORT_KEY'		=> 	$s_sort_key,
						'S_PSORT_DIR'		=> $s_sort_dir,
						'S_PAGE_ACTION'		=> $this->u_action,
				));

			break;
			}
			
		if( $acct_id ) {
			$vm_stat = 'billing3';
			$vm_rslt = $soap->send(GET_FEATURE_OFFERINGS, array($cust_id, $acct_id), $vm_stat, false, true);
			$voicemail_offerings = $vm_rslt->xpath('//row[FEATURE_TYPE_ID = "4" and FEATURE_OFFERING_LEVEL = "1"]');
	
			$vm_select = '<select id="voicemail_subs" name="voicemail_subs">';
			$vm_select .= '<option value="0">'.$user->lang['NO_VOICEMAIL'].'</option>';
			foreach ( $voicemail_offerings as $option )
			{
				$vm_select .= '<option value="'.$option->FEATURE_OFFERING_ID.'">'.$option->FEATURE_NAME.'</option>';
			}
			$vm_select .= '</select>';
			$status = 'autoprovisioning';
			$result = $soap->send(GET_PHONE_TYPE_AVAILABILITY, array(), $status, false, true);
	
			$result = $result->xpath('//row[AVAIL_TO_ACCT_ID = "'.$acct_id.'" and AVAIL_TO_CUST_ID=""]');
			$device_type = '<option value="">' . $user->lang['SELECT_ONE'] . '</option>';
			if(sizeof($result)){
				foreach ($result as $option) {
					$selected = ($option->PHONE_TYPE == $phone_type) ? ' selected="selected"' : '';
					$device_type .= '<option value="' . $option->PHONE_TYPE . '" '.$selected.'>' . $option->PHONE_TYPE . '</option>';
				}
			}
			else
			{
				confirmation_box(array('status' => '', 'error_message' => $user->lang['NO_DEVICE_OFFERED']), 'NO_DEVICE');
			}
			$template->assign_vars(array(
				'VOICEMAIL_SELECT'	=> $vm_select,
				'DEVICE_LIST_OPTIONS'=> $device_type,
			));
		}
		
		if ($user->data['managed_did']){
			// create did list for this customer
			$selectedDID = '';
			$opts = getDIDSelect($cust_id, request_var('did', ''), false );
			$template->assign_vars(array(
				'DID_OPTIONS' => $opts,
			));
		}

		$template->assign_vars(array(
			'MANAGED_DID'		=> $user->data['managed_did'],
			'EXPOSE_EP_ALIAS'	=> isset($config['expose_epalias'])?$config['expose_epalias']:false,
			'U_READ_ONLY'		=> $read_only,
			'U_ADD_SUBSCRIBER'	=> $this->u_action . '&amp;action=details',
			'S_ACTION'			=> $action,
			'U_ACTION'			=> $this->u_action
		));
	}

	function add_subscriber()
	{
		global $user, $config, $common_path, $phpEx;

		require($common_path . 'includes/functions_user.' . $phpEx);

		// grab some user input data
		$ep_pin = request_var('ep_pin', '');
		if (request_var('assign_features', false)) {
			$assign_features = 'true';
		}
		else {
			$assign_features = 'false';
		}
		$data = array(
			'login_name'	=> utf8_normalize_nfc(request_var('login_name', '', true)),
			'password'		=> request_var('password', '', true),
			'email'			=> request_var('email', ''),
			'first_name'	=> utf8_normalize_nfc(request_var('first_name', '', true)),
			'last_name'		=> utf8_normalize_nfc(request_var('last_name', '', true)),
			'ep_alias'		=> request_var('ep_alias', ''),
			'ep_pin'		=> $ep_pin,
			'alt_id'		=> request_var('alt_id', ''),
			'limit'			=> amount_convert_from_display(request_var('limit', '')),
			'balance'		=> amount_convert_from_display(request_var('balance', '')),
			'did'			=> preg_replace( '/[\D]/', '', request_var('did', '')),
			'voicemail'		=> request_var('voicemail_subs', 0),
			'tz_id'			=> request_var('tz_select', 'UTC'),
			'language'		=> request_var('lang_select', 'en'),
		);

		$xml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
		$xmldata = $xml->addChild('data');
		$row = $xmldata->addChild('row');

		if ($this->module_class == 'enterprise')
		{
			$row->addChild('ACCT_ID', request_var('acct_id', 0));
			$row->addChild('CUST_ID', request_var('cust_id', 0));
			$row->addChild('BALANCE', $data['balance']);
			$row->addChild('STATUS', 12);
			$row->addChild('TTL', 0);
			$row->addChild('RESELLER_ID', $user->data['rsid']);
			$row->addChild('ERR_COUNTER', 0);
			$row->addChild('LIMIT', $data['limit']);
			$row->addChild('PREPAID_CARD_SEQ');
			$row->addChild('FEEPLAN_ID', request_var('fee_id', 0));
			$row->addChild('USER_NAME', $data['login_name']);
			$row->addChild('PASSWORD', $data['password']);
			$row->addChild('ALT_ID', $data['alt_id']);
			$row->addChild('LANGUAGE', $data['language']);
			$row->addChild('TZ_ID', $data['tz_id']);
			$row->addChild('PIN', $data['ep_pin']);
			$contact = $row->addChild('contact');
				$contact->addChild('LASTNAME', $data['last_name']);
				$contact->addChild('FIRSTNAME', $data['first_name']);
				$contact->addChild('EMAIL', $data['email']);
				$contact->addChild('CONTACT_TYPE_ID', 1);
				$phone = $row->addChild('phone');
				$phone->addChild('PHONE_ID', 1);
				$phone->addChild('MAC_ADDR',request_var('mac_address',''));
				$phone->addChild('PHONE_TYPE', request_var('phone_type',''));
				$phone_line = $phone->addChild('phoneline');
					$phone_line->addChild('LINE_ID', 1);
					$phone_line->addChild('EP_ALIAS', $data['ep_alias']);
					$phone_line->addChild('EP_PIN', $data['ep_pin']);
					$number = $phone_line->addChild('NUMBER', $data['did']);
						$number->addAttribute('type', 'DID');
						$number->addAttribute('main', 'true');
						if ($data['voicemail'])
						{
							$number->addAttribute('vmOfferingId', $data['voicemail']);
							$number->addAttribute('mailbox', $data['did']);
						}
		}
		else
		{
			$row->addChild('ACCT_ID', request_var('acct_id', 0));
			$row->addChild('CUST_ID', request_var('cust_id', 0));
			$row->addChild('BALANCE', $data['balance']);
			$row->addChild('STATUS', 12);
			$row->addChild('TTL', 0);
			$row->addChild('RESELLER_ID', $user->data['rsid']);
			$row->addChild('ERR_COUNTER', 0);
			$row->addChild('LIMIT', $data['limit']);
			$row->addChild('PREPAID_CARD_SEQ');
			$row->addChild('FEEPLAN_ID', request_var('fee_id', 0));
			$row->addChild('USER_NAME', $data['login_name']);
			$row->addChild('PASSWORD', $data['password']);
			$row->addChild('ALT_ID', $data['alt_id']);
			$row->addChild('LANGUAGE', $data['language']);
			$row->addChild('TZ_ID', $data['tz_id']);
			$row->addChild('PIN', $data['ep_pin']);
			$contact = $row->addChild('contact');
				$contact->addChild('LASTNAME', $data['last_name']);
				$contact->addChild('FIRSTNAME', $data['first_name']);
				$contact->addChild('EMAIL', $data['email']);
				$contact->addChild('CONTACT_TYPE_ID', 1);
				$phone = $row->addChild('phone');
				$phone->addChild('PHONE_ID', 1);
				$phone->addChild('MAC_ADDR',request_var('mac_address',''));
				$phone->addChild('PHONE_TYPE', request_var('phone_type',''));
			    $phone->addChild('ASSIGN_FEATURES', $assign_features);
				$phone_line = $phone->addChild('phoneline');
					$phone_line->addChild('LINE_ID', 1);
					$phone_line->addChild('EP_ALIAS', $data['ep_alias']);
					$phone_line->addChild('EP_PIN', $data['ep_pin']);
					$number = $phone_line->addChild('NUMBER', $data['did']);
						$number->addAttribute('type', 'DID');
						$number->addAttribute('main', 'true');
						if ($data['voicemail'])
						{
							$number->addAttribute('vmOfferingId', $data['voicemail']);
							$number->addAttribute('mailbox', $data['did']);
						}
		}
		return $xml;
	}
}

//classes for soap calls
class subfeature
{
	public $mainNumber	= '';
	public $feature0  	= '';//ring (none/multi/sequential)
	public $feature1  	= 3;
	public $feature2  	= 4;
	public $feature3  	= 5;
	public $feature4  	= 999;
	public $feature5  	= 6;
	public $feature6  	= 7;
	public $feature7  	= 8;
	public $feature8	= 9;
	public $feature9	= 10;
	public $feature10	= 0;
	public $feature11	= 0;
	public $feature12	= 0;
	public $feature13	= 0;
	public $feature14	= 0;
	public $feature15	= 0;
	public $status0   	= 0;//ring (none/multi/sequential)
	public $status1   	= 0;
	public $status2   	= 0;
	public $status3   	= 0;
	public $status4   	= 0;
	public $status5   	= 1;
	public $status6   	= 0;//turning off anonymous call barring by default
	public $status7   	= 1;
	public $status8		= 0;
	public $status9		= 1;
	public $status10	= 0;
	public $status11	= 0;
	public $status12	= 0;
	public $status13	= 0;
	public $status14	= 0;
	public $status15	= 0;

	function __construct($data = array())
	{
		if ( sizeof($data) )
		{
			$ignore_fields = array('reserved', 'user_defined', 'entity_id', 'user_domain', 'read_level', 'write_level', 'data_version',
				'data_status', 'last_transact', 'last_modified', 'modified_date');

			$name_change = array(
				'main_number'	=> 'mainNumber',
				'feature_0'		=> 'feature0', 'feature_1'		=> 'feature1', 'feature_2'		=> 'feature2',
				'feature_3'		=> 'feature3', 'feature_4'		=> 'feature4', 'feature_5'		=> 'feature5',
				'feature_6'		=> 'feature6', 'feature_7'		=> 'feature7', 'feature_8'		=> 'feature8',
				'feature_9'		=> 'feature9', 'feature_10'		=> 'feature10', 'feature_11'	=> 'feature11',
				'feature_12'	=> 'feature12', 'feature_13'	=> 'feature13', 'feature_14'	=> 'feature14',
				'feature_15'	=> 'feature15',
				'status_0'		=> 'status0', 'status_1'		=> 'status1', 'status_2'		=> 'status2',
				'status_3'		=> 'status3', 'status_4'		=> 'status4', 'status_5'		=> 'status5',
				'status_6'		=> 'status6', 'status_7'		=> 'status7', 'status_8'		=> 'status8',
				'status_9'		=> 'status9', 'status_10'		=> 'status10', 'status_11'		=> 'status11',
				'status_12'		=> 'status12', 'status_13'		=> 'status13', 'status_14'		=> 'status14',
				'status_15'		=> 'status15'
			);
			foreach ($data as $var => $val)
			{
				if ( !in_array(strtolower($var), $ignore_fields) )
				{
					if ($val != '')
					{
						$this->$name_change[$var] = $val;
					}
				}
			}
		}
	}
}

class subfeatureparm
{

    public $mainNumber	= '';
    public $feature		= '';
    public $fParm		= '';
    public $fNumber		= '';
    public $fAction		= 0;

	function __construct($mainNumber = '', $feature = '', $fParm = '', $fNumber = '', $fAction = 0)
	{
		$this->mainNumber	= $mainNumber;
		$this->feature		= $feature;
		$this->fParm		= $fParm;
		$this->fNumber		= $fNumber;
		$this->fAction		= $fAction;
	}

	function init($parms)
	{
		$this->mainNumber	= strval($parms['MAIN_NUMBER']);
		$this->feature		= strval($parms['FEATURE']);
		$this->fParm		= strval($parms['F_PARM']);
		$this->fNumber		= strval($parms['F_NUMBER']);
		$this->fAction		= strval($parms['F_ACTION']);
	}
}

class contactbean
{
	public $address1		= '';
	public $address2		= '';
	public $address3		= '';
	public $subscriberId	= '';
	public $city			= '';
	public $company			= '';
	public $contactTypeId	= '';
	public $contId			= '';
	public $country			= '';
	public $custId			= '';
	public $email			= '';
	public $faxNum			= '';
	public $firstName		= '';
	public $lastName		= '';
	public $misc			= '';
	public $mobileNum		= '';
	public $phoneNum		= '';
	public $postal			= '';
	public $state			= '';
	public $title			= '';
}

/**
 * Generate network feature status drop down
 * States are: unsubscribed, enabled, and disabled.
 *
 * @param string $id
 * @param int $current_state
 * @param string $extra_html
 * @return string select box of feature status
 */
function gen_network_feature_status($id = '', $current_state = 0, $extra_html = '')
{
	global $user;

	$states = array(
		$user->lang['UNSUBSCRIBED'],
		$user->lang['ENABLED'],
		$user->lang['DISABLED'],
	);

	$name = ($id != '')? $id : 'net_feat_status';

	$select = '<select id="' . $name . '" name="' . $name . '" ' . $extra_html . '>';
	for ($i = 0; $i < 3; $i++)
	{
		$selected = ($current_state == $i) ? ' selected="selected"' : '';
		$select .= '<option value="' . $i . '"' . $selected . '>' . $states[$i] . '</option>';
	}
	$select .= '</select>';

	return $select;
}

?>