<?php
/**
*
* common [English]
*
* @author Lorence Smith
* @package reseller modules
* @version $Id: view_charges.php,v 1.51 2011/01/07 21:30:47 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

/**
* reseller_agent_maintenance
* Reseller Agent Maintenance
* @package reseller
*/
class view_charges {

	public $u_action;
	public $module_class;

	function main($id, $mode) {
		global $soap, $user, $common_path, $phpEx, $template, $config, $read_only,$reseller_id;

		$action		= request_var('action', '');
		$acct_id	= request_var('acct_id', 0);
		$cust_id	= request_var('cust_id', 0);
		$fee_id		= request_var('fee_id', 0);
		$sub_id		= request_var('sub_id', '');
		$payments	= null;
		$invoices	= null;
		$charges	= null;
		if ( post_var('inv_url') ) {
			$inv_url = request_var('inv_url', '');
			if ( strlen($user->data['invoice_url']) <= 0 ) {
				trigger_error(print_r('NO_URL'));
			}
			$content = file_get_contents(html_entity_decode($user->data['invoice_url']));
			$template->assign_vars(array(
				'FETCH_INVOICE'	=> true,
				'PAGE_DATA'		=> $content,
			));
			return;
		}

		if ( strlen($cust_id) ) {
			$page = array(
				'AGENTS'		=> $this->u_action,
				'SUBSCRIBERS'	=> str_replace(array('i=' . $id, 'mode=' . $mode), array('i=subscriber', 'mode=view_charges'), $this->u_action) . '&amp;action=details'. '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id . '&amp;fee_id=' . $fee_id,
			);
		}
		else {
			$page = array(
				'AGENTS'	=> $this->u_action,
			);
		}
		breadcrumbs($page);

		$sub_id_param = ($sub_id) ? '&amp;sub_id=' . $sub_id : '';
		$this->u_action .= ($acct_id && $cust_id) ? $sub_id_param . '&amp;acct_id=' . $acct_id . '&amp;cust_id=' . $cust_id . '&amp;fee_id=' . $fee_id : '';

		if ( post_var('add_charge') ) {
			if ( $charges == null ) {
				require_once("{$common_path}modules/charges/charges.$phpEx");
				$charges = new charges();
			}

			$charges->addCharges($cust_id, $acct_id, $sub_id);
			$action = 'view_fees';
		}
		else if ( post_var('expire_charge') ) {
			if ( $charges == null ) {
				require_once("{$common_path}modules/charges/charges.$phpEx");
				$charges = new charges();
			}
			$charges->expireCharge();
			$action = 'view_fees';
		}
		else {
			require_once("{$common_path}modules/payments/payments.$phpEx");
			$payments = new payments($cust_id, $sub_id, 4);
			$action = $payments->processPage( $action );
		}

		//now the viewing actions
		switch ($action) {
			case 'invoices':
				$invoice_no = request_var('invoice_no', 0);
				if ( $invoices == null ) {
					require_once("{$common_path}modules/invoices/invoices.$phpEx");
					$invoices = new invoices();
				}
				if ( $invoice_no ) {
					$invoice_url = $invoices->fetchInvoice($sub_id, 4, $invoice_no);
					$_SESSION['invoice_url'] = htmlspecialchars($invoice_url);
					$user->data['invoice_url'] = htmlspecialchars($invoice_url);
					$template->assign_var('INVOICE_URL', html_entity_decode($this->u_action).'&inv_url=true');
				}

				$invoices->displayInvoiceList($sub_id, 4, $this->u_action . '&amp;action='.$action);

			break;

			case 'view_call_records':
				$this->u_action .= '&amp;action=view_call_records';
				// Sorting
				$csort_key	= request_var('ck', 'a');
				$csort_dir	= request_var('cd', 'a');
				$climit		= request_var('climit', 100);
				$climit		= ($climit > 100) ? 100 : $climit;
				$cstart		= request_var('cstart', 0);
				$cpage = ceil(($cstart + 1) / $climit);

				$csort_by_text = array(
					'a' => $user->lang['DEFAULT'],
					'b'	=> $user->lang['CLG_NUM'],
					'c'	=> $user->lang['CLD_NUM'],
					'd'	=> $user->lang['AMOUNT'],
					'e'	=> $user->lang['CALL_DIRECTION'],
				);
				$csort_by_sql = array(
					'a'	=> 'user_id',
					'b'	=> 'clg_num',
					'c'	=> 'cld_num',
					'd'	=> 'call_amount',
					'e'	=> 'call_direction',
				);
				$ckeys = array('ck', 'cd');
				$s_csort_key = $s_csort_dir = $u_csort_param = '';
				gen_sort_selects($csort_by_text, $csort_key, $csort_dir, $s_csort_key, $s_csort_dir, $u_csort_param, $ckeys);

				// Searching
				$sfilter = search_results('rcr', $cstart);
				search_options('rcr', array(
					'RATED_CALL_RECORDS'	=> 'disabled',

					'clg_NUM'			=> 'CLG_NUM',
					'cld_num'			=> 'CLD_NUM',
					'call_amount'		=> 'AMOUNT',
					'call_direction'	=> 'CALL_DIRECTION',
				));
				//allow 'missed', 'inbound', and 'outbound' as search value for call direction
				$search_arr=explode('|',$sfilter);
				for($i = 0; $i < count($search_arr); $i=$i+3) {
					if($search_arr[$i]=='call_direction') {
						if(($i+2)>=count($search_arr))
						   break;
						if(strtoupper($search_arr[$i+2])==strtoupper($user->lang['call_dir'][0]))
							$search_arr[$i+2]=0;
						elseif(strtoupper($search_arr[$i+2])==strtoupper($user->lang['call_dir'][1]))
							$search_arr[$i+2]=1;
						elseif(strtoupper($search_arr[$i+2])==strtoupper($user->lang['call_dir'][2]))
							$search_arr[$i+2]=2;
					}
				}
				$sfilter='';
				for($i=0;$i<count($search_arr);$i++) {
					if($search_arr[$i])
						$sfilter.=$search_arr[$i].'|';
				}
				$status = 'billing3';
				$result = $soap->send(GET_BILL_BY_ACCT, array($acct_id), $status, false, true);
				$result = $result->data->row;

				$period = request_var('period', 0);
				$rtn = get_billing_period($result->CYCLE_CLOSE_FLAG, $result->CYCLE_CLOSE_DATE, $period);
				$start_time = ($rtn['start_time'])?$rtn['start_time']:'';
				$end_time = ($rtn['end_time'])?$rtn['end_time']:'';

				$pagenum = $cpage;
				$pagesize= $climit;
				$sortfield = $soap->soap_build_orderby(array('ORDER_BY'	=> "{$csort_by_sql[$csort_key]} {$csort_dir}"), '');
				$filter = $sfilter . 'user_id|=|'.$sub_id.'|';
				$xml_ary = array(
					$start_time,
					$end_time,
					$pagenum,
					$pagesize,
					$sortfield,
					$filter,
				);

				$status = 'billing3';
				$result = $soap->send(GET_RATED_CALL_RECORDS, $xml_ary, $status, false, true);
				$ctot_row = (int)$result->data->TOTAL_ROWS;
				$ctot_cost = (int)$result->data->TOTAL_COST;
				$total_call = $total_conn = 0;
				$result = $result->data->row;

				if (sizeof($result)) {
					foreach ($result as $row) {
						($row->UNIT > 0) ? $unit = (int)$row->UNIT : $unit = 1;
						$dur_min = sprintf("%02d", floor($row->CALL_DURATION/60));
						$dur_seconds = sprintf("%02d", ($row->CALL_DURATION % 60));
						$rate = currency_to_display(floatval($row->RATE), false, $config['long_decimal_places']);
						if ( $row->CALL_DIRECTION == 2 && $row->CALL_DURATION == 0 ) {
							$row->CALL_DIRECTION = 0;
						}
						$template->assign_block_vars('ratedcalls', array(
							'CLG_NUM'			=> $row->CLG_NUM,
							'CLD_NUM'			=> $row->CLD_NUM,
							'CLD_AREA_DESC'		=> ((int)$row->CALL_DIRECTION == 1)? $row->CLD_AREA_DESC : $user->lang['INBOUND'],
							'CLD_NOA'			=> isset($user->lang['noa_types'][(int)$row->LINE_CHG_NATURE])?$user->lang['noa_types'][(int)$row->LINE_CHG_NATURE]:$row->LINE_CHG_NATURE,
							'CALL_DIRECTION'	=> $user->lang['call_dir'][(int)$row->CALL_DIRECTION],
							'ANSWER_TIME'		=> date(DISPLAY_DATE_FORMAT, strtotime($row->ANSWER_TIME)),
							'DISCONNECT_TIME'	=> date(DISPLAY_DATE_FORMAT, strtotime($row->DISCONNECT_TIME)),
							'DURATION'			=> $dur_min.":".$dur_seconds,
							'RATE'				=> $rate, 
							'UNIT'				=> $unit,
//							'RATE'				=> amount_convert_to_display($rate, $config['long_decimal_places']),
							'CONN_CHRG'			=> amount_convert_to_display($row->CONN_CHRG),
							'CONN_CHRG'			=> currency_to_display($row->CONN_CHRG),
							'TOT_MISC_CHRG'		=> amount_convert_to_display($row->CONN_CHRG+$row->DISCONN_CHRG+$row->HIDDEN_CHRG+$row->ACC_NUM_CHRG+$row->INIT_PRD_CHRG),
							'TOT_MISC_CHRG'		=> currency_to_display($row->CONN_CHRG+$row->DISCONN_CHRG+$row->HIDDEN_CHRG+$row->ACC_NUM_CHRG+$row->INIT_PRD_CHRG),
							'CALL_AMOUNT'		=> amount_convert_to_display($row->CALL_AMOUNT),
							'CALL_AMOUNT'		=> currency_to_display($row->CALL_AMOUNT),
						));
						$total_conn += floatval($row->CONN_CHRG);
						$total_call += floatval($row->CALL_AMOUNT);
					}
				}

				$template->assign_vars(array(
					'S_VIEW_CDR'	=> true,

					'PERIOD'			=> $period,
					'U_NEXT_PERIOD'		=> $this->u_action . '&amp;period='.($period+1),
					'U_PREVIOUS_PERIOD'	=> $this->u_action . '&amp;period='.($period-1),

					'START_DATE'		=> date(DISPLAY_SHORT_DATE_FORMAT, $start_time),
					'END_DATE'			=> date(DISPLAY_SHORT_DATE_FORMAT, $end_time),

//					'TOTAL_CONN'		=> number_format($total_conn/pow(10, $config['decimal_places']), $config['decimal_places'], $config['decimal_seperator'], $config['thousands_seperator']),
					'TOTAL_CALL'		=> amount_convert_to_display($total_call),
					'TOTAL_AMOUNT'		=> amount_convert_to_display($ctot_cost),

					// pagination
					'PAGINATION'	=> generate_pagination(str_replace('&amp;cstart=' . $cstart, '', $this->u_action . '&amp;period='.$period.'&amp;climit=' . $climit), $ctot_row, $climit, $cstart, true, '', 'cstart'),
					'PAGE_NUMBER'	=> on_page($ctot_row, $climit, $cstart),

					// Sorting
					'S_CSORT_KEY'			=> $s_csort_key,
					'S_CSORT_DIR'			=> $s_csort_dir,
				));
			break;

			case 'view_fees':
				$status = 'billing3';
				$result = $soap->send(GET_BILL_BY_ACCT, array($acct_id), $status, false, true);
				$result = $result->data->row;

				$period = request_var('period', 0);
				// get weekly billing cycle
				$start_cur_period = '';
				if ( strtoupper($result->CYCLE_CLOSE_FLAG) == '1W' ) {
					switch ($result->CYCLE_CLOSE_DATE) {
						case 1: $billday = 'Sunday'; break;
						case 2: $billday = 'Monday'; break;
						case 3: $billday = 'Tuesday'; break;
						case 4: $billday = 'Wednesday'; break;
						case 5: $billday = 'Thursday'; break;
						case 6: $billday = 'Friday'; break;
						case 7: $billday = 'Saturday'; break;
						default : $billday = 'Monday';
					}

					$next_bill_period = strtotime('next '. $billday);

					$start_time = mktime(0, 0, 0, date('m', $next_bill_period), date('j', $next_bill_period)+(7 * ($period-1)));
					$start_cur_period = mktime(0, 0, 0, date('m', $next_bill_period), date('j', $next_bill_period)+(7 * (0-1)));
					$end_time = mktime(23, 59, 59, date('m', $start_time), date('j', $start_time)+(6));

					$template->assign_vars(array(
						'MAX_YEAR'			=> date('Y', $end_time),
						'MAX_MON'			=> date('m', $end_time)-($period+1),
						'MAX_DAY'			=> date('d', $end_time)+7,
					));
				}
				// get monthly billing cycle
				else {
					$day = (int)$result->CYCLE_CLOSE_DATE;
					$end_time = mktime(23, 59, 59, ( $day <= date('j') )?date('m') + $period + 1:date('m') + $period, $day-1);
					$start_time = mktime(0, 0, 0, ( $day == 1 )? date('m', $end_time):date('m', $end_time) - 1, $day, date('Y', $end_time));

					$end_cur_period = mktime(23, 59, 59, ( $day <= date('j') )?date('m') + 0 + 1:date('m') + 0, $day-1);
					$start_cur_period = mktime(0, 0, 0, ( $day == 1 )? date('m', $end_cur_period):date('m', $end_cur_period) - 1, $day, date('Y', $end_cur_period));
					$template->assign_vars(array(
						'MAX_YEAR'			=> date('Y', $end_time),
						'MAX_MON'			=> date('m', $end_time)-$period,
						'MAX_DAY'			=> (date('d', $start_time) == 1)? date('t', strtotime('+1 month', $start_time)) : date('d', $end_time)+1,
					));
				}



				$template->assign_vars(array(
					'S_VIEW_FEES'		=> true,

					'PERIOD'			=> $period,
					'CURRENT_URL'		=> $this->u_action . '&amp;action=view_fees&amp;sub_id='.$sub_id.'&amp;period=0',
					'NEXT_URL'			=> $this->u_action . '&amp;action=view_fees&amp;sub_id='.$sub_id.'&amp;period='.($period+1),
					'PREVIOUS_URL'		=> $this->u_action . '&amp;action=view_fees&amp;sub_id='.$sub_id.'&amp;period='.($period-1),

					'START_DATE'		=> date(DISPLAY_SHORT_DATE_FORMAT, $start_time),
					'END_DATE'			=> date(DISPLAY_SHORT_DATE_FORMAT, $end_time),

					'MIN_YEAR'			=> date('Y', $start_time),
					'MIN_MON'			=> date('m', $start_time)-($period+1),
					'MIN_DAY'			=> date('d', $start_time),

				));
				if ( $charges == null ) {
					require_once("{$common_path}modules/charges/charges.$phpEx");
					$charges = new charges();
				}
				$sortField='';
				$filter="C.PPR_USER_ID|=|".$sub_id."|";
				$charges->getCharges($start_time, $end_time, 1, 50, $sortField, $filter, $start_cur_period);
			break;

			case 'details':
				$limit = request_var('limit', 10);
				$start = request_var('start', 0);

				$filter = search_results('subscriber', $start);
				$filter .= 'cust_id|=|'.$cust_id.'|acct_id|=|'.$acct_id.'|';
				search_options('subscriber', array(
					'SUBSCRIBERS'	=> 'disabled',

					'user_id'		=> 'SUBSCRIBER_ID',
					'firstname'		=> 'FIRST_NAME',
					'lastname'		=> 'LAST_NAME',
				));

				if ($limit <= 0) {
					$limit = 25;
				}
				$page = ceil(($start + 1) / $limit);

				$array = array(
					$page,
					$limit,
					'', //sort field
					$filter, //filter
				);

				$status = 'billing3';
				$result = $soap->send(GET_SUBSCRIBER_PAGED, $array, $status, false, true);
				$total_rows = 0;

				if ( !$result->error ) {
					$total_rows = $result->data->TOTAL_ROWS;

					$status = 'billing3';
					$bill_plan = $soap->send(GET_BILL_BY_ACCT, array($acct_id), $status, false, true);
					$bill_plan = $bill_plan->data->row;
					$bill_period = get_billing_period($bill_plan->CYCLE_CLOSE_FLAG, $bill_plan->CYCLE_CLOSE_DATE, -1);
					$due_offset = $bill_plan->BILLDUEDATE - 1;

					foreach ($result->data->row as $sub)
					{
						$template->assign_block_vars('details', array(
							'NAME'				=> $sub->FIRSTNAME.' '.$sub->LASTNAME,
							'ALT_ID'			=> (string)$sub->ALT_ID,
							'SUB_ID'			=> $sub->USER_ID,

							'PAST_DUE'			=> (strtotime('now') > strtotime("+1 second +$due_offset day", $bill_period['end_time']))? true: false,
							'BILL_HISTORY_SUM'	=> ($sub->CURRENT_DUE)?$sub->CURRENT_DUE:false,
//							'U_VIEW_FEES'		=> str_replace('&amp;search_results=1', '', $this->u_action) . '&amp;action=view_fees&amp;sub_id='.$sub->USER_ID,
//							'U_CALL_RECORDS'	=> str_replace('&amp;search_results=1', '', $this->u_action) . '&amp;action=view_call_records&amp;sub_id='.$sub->USER_ID,
//							'U_PAYMENTS'		=> str_replace('&amp;search_results=1', '', $this->u_action) . '&amp;action=payments&amp;sub_id='.$sub->USER_ID,
//							'U_INVOICES'		=> str_replace('&amp;search_results=1', '', $this->u_action) . '&amp;action=invoices&amp;sub_id='.$sub->USER_ID,
							'U_VIEW_FEES'		=> ($this->u_action) . '&amp;action=view_fees&amp;sub_id='.$sub->USER_ID,
							'U_CALL_RECORDS'	=> ($this->u_action) . '&amp;action=view_call_records&amp;sub_id='.$sub->USER_ID,
							'U_PAYMENTS'		=> ($this->u_action) . '&amp;action=payments&amp;sub_id='.$sub->USER_ID,
							'U_INVOICES'		=> ($this->u_action) . '&amp;action=invoices&amp;sub_id='.$sub->USER_ID,
						));
					}
				}

				$template->assign_vars(array(
					'CUST_ID'			=> $cust_id,
					'ACCT_ID'			=> $acct_id,
				    'FEE_ID'			=> $fee_id,

				    // pagination
					'PAGINATION'	=> generate_pagination(str_replace('&amp;start=' . $start, '', $this->u_action . '&amp;action=details&amp;limit=' . $limit), $total_rows, $limit, $start, true),
					'PAGE_NUMBER'	=> on_page(sizeof($result), $limit, $start),
				));
			break;

			default:
				$psort_dir	= request_var('sd', 'a');
				$psort_key	= request_var('sk', 'acct_new_id');

				// sort by elements
				$sort_by_text = array(
					'p'		=> $user->lang['PRODUCTS'],
					'r'		=> $user->lang['AGENTS'],
				);

				// the keys must match the above sort by. -- the below values must correspond to the soap call/database
				$sort_by_sql = array(
					'p'		=> 'acct_new_id',
					'r'		=> 'name',
				);

				$s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($sort_by_text, $psort_key, $psort_dir, $s_sort_key, $s_sort_dir, $u_sort_param);
				// this will ensure that the sort directions are retained in pagination.
				$this->u_action .= '&amp;' . $u_sort_param;
				$filter = search_results('view_charge', $start, false);
				search_options('view_charge', array(
					'SUBSCRIBER_CHARGES'		=> 'disabled',

					'c.acct_new_id'		=> 'PRODUCTS',
					'b.name'			=> 'AGENTS',
				));
				$xml_ary = array ('SELECT' => 'b.name, b.cust_id, c.acct_new_id, c.tax, c.acct_id',
		                  'FROM' => array (CUSTOMER_TABLE => 'a' ),
		                  'LEFT_JOIN' =>array (
										array ('FROM' => array (CUSTOMER_TABLE => 'b' ),
		                                          'ON' => 'a.cust_new_id = b.signup_by'),
						  'INNER_JOIN' =>array ('FROM' => array (ACCOUNT_TABLE => 'c' ),
		                                        'ON' => 'c.cust_id = b.cust_id'  ) ),
   						'WHERE'		=> 'b.business_type_id = 1 AND a.cust_id = ' . $user->data['rsid'] . '  AND c.account_type_id = ' . AGENT_AGENT. (($filter) ? ' AND ' . $filter : '') ,
						'ORDER_BY'	=> $sort_by_sql[$psort_key] . ' ' . $psort_dir,);
				$status = 'stratus';
				$agent_results = $soap->soap_request($xml_ary, $status);
				$total_rows = $status['total_rows'];
				$cust_ary = array();
				if (sizeof($agent_results)) {
					foreach ($agent_results as $row) {
						$cust_ary[$row['cust_id']] = $row['cust_id'];
					}
				}

				foreach ($agent_results as $row) {
					$template->assign_block_vars('products', array(
						'PRODUCT_NAME'		=> $row['acct_new_id'],
						'AGENT_NAME'		=> $row['name'],
						'PRODUCT_ID'		=> $row['acct_id'],
						'U_DETAILS'			=> $this->u_action . '&amp;action=details&amp;acct_id=' . $row['acct_id'] . '&amp;cust_id=' . $row['cust_id'] . '&amp;fee_id=' . $row['tax'],
					));
				}

				$template->assign_vars(array(
					'S_PSORT_KEY'		=> 	$s_sort_key,
					'S_PSORT_DIR'		=> $s_sort_dir,
					'S_PAGE_ACTION'		=> $this->u_action,
				));
			break;
		}

		$template->assign_vars(array(
			'U_ACTION'			=> $this->u_action,
			'S_ACTION'			=> $action,
			'U_READ_ONLY'		=> $read_only,
			'U_CHARGES_ACTION'	=> $this->u_action . '&amp;action=view_fees&amp;sub_id=' . $sub_id,
		));
	}

	function get_subid_name($array) {
		return array($array['subscriber_id'], $array['fullname']);
	}
}
?>